       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGCMN. 
      **** rel 7.2
      *    Nuovo
      ************
      *
      *    Interfaccia MOVIME per modifica competenza
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'grimovsl'.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'griclfsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'grimov'.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'griclf'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'grimovrk'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'grit25rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parmb'.
           COPY 'parvmov'.
           COPY 'parppar'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  COMODI.
           05 SF-MOV   PIC XX.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CLF   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(50).
           05 IF-AZI   PIC 9(3).
           05 DADATA   PIC 9(5).
           05 ADATA    PIC 9(5).
           05 SAV-FLGPC PIC 9.
           05 SAV-AA   PIC 99.
           05 SAV-MM   PIC 99.
           05 DTAPE    PIC 9(5) COMP-3.
           05 DTINI    PIC 9(5).
       LINKAGE SECTION.
           COPY 'gricmnrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-CMC-CTRL
                                RG-CMC-REC
                                RA-CMC-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclmov'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'dclclf'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-CMC-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-CMC-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           IF (RG-CMC-FUN = 'N' OR 'n') AND
              (RG-CMC-EOF = 2 OR 3)     GO TO ESCI.
           IF (RG-CMC-FUN = 'P' OR 'p') AND
              (RG-CMC-EOF = 1 OR 2)     GO TO ESCI.
           MOVE RG-CMC-FUN   TO FUN.
           MOVE RG-CMC-IDX   TO IDX.
           MOVE RG-CMC-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-CMC-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vrgcmn: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-CMC-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-CMC-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-CMC-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.

           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK MOVIME.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-MOV INVALID
              PERFORM INVK-MOV
              GO TO ERRIO.
      *
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      *
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-MOV INVALID
              PERFORM INVK-MOV
              GO TO ERRIO.
           UNLOCK MOVIME.
      *
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      *
           PERFORM AGG-REG THRU EX-AGG-REG
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-MOV
              GO TO WARNING.
           IF RG-CMC-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           DELETE MOVIME INVALID
              PERFORM INVK-MOV
              GO TO ERRIO.
           UNLOCK MOVIME.
      *
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      *
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-CMC-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK MOVIME.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-CMC-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE MOVIME.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-CMC-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-CMC-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'grimover'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'griclfer'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
      **** rel 4.0
           IF RG-CMC-FL = ZERO 
              MOVE 'movime' TO ID-MOV
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'anaclf' TO ID-CLF
           ELSE                
              MOVE 'movmol' TO ID-MOV
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'anacfx' TO ID-CLF
           END-IF.                
      ************
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACLF.
           OPEN I-O MOVIME.
           MOVE RG-CMC-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
                       PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
      *
           MOVE AZI-DTAPE TO DTAPE.
           IF T25-ESE = 1 MOVE AZI-DTAPE  TO AAGGG
                          MOVE 2          TO TIPOP1
                          CALL 'rdata' USING PARCDT
                          MOVE 1 TO GG9
                          MOVE 1 TO MM9
                          MOVE 1 TO TIPOP1
                          CALL 'rdata' USING PARCDT
                          MOVE AAGGG      TO DTAPE.
      *
           IF T25-DUP = ZERO 
              MOVE DTAPE   TO DTINI
           ELSE 
              MOVE T25-DUP TO DTINI
           END-IF.
      *
           MOVE 1 TO TIPOP1.
           MOVE RG-CMC-DA-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO DADATA.
           MOVE RG-CMC-A-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ADATA.
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-CMC-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
      *    MOVE RG-CMC-AZI TO KMV-AZI.
      *    MOVE RG-CMC-CON TO KMV-CON.
      *    MOVE 1          TO TIPOP1.
      *    MOVE RG-CMC-DAT TO GGMMAA.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE AAGGG      TO KMV-DAT.
      *    MOVE RG-CMC-DAT TO KMV-DAT.
      *    MOVE RG-CMC-NUM TO KMV-NUM.

           MOVE RG-CMC-AZI     TO KMV-AZI.
           MOVE RG-CMC-C-CDCON TO KMV-CON.
           MOVE RG-CMC-C-DAT   TO KMV-DAT.
           MOVE RG-CMC-C-NUM   TO KMV-NUM.

           MOVE KEYMV TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYMV.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ MOVIME INTO REKMOV INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-MOV = '9D' OR '9A' OR '35' MOVE RF-MOV TO REKMOV.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ MOVIME INTO REKMOV KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-MOV > ZERO MOVE 7 TO RG-CMC-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ MOVIME PREVIOUS INTO REKMOV AT END MOVE 1 TO EOF
           ELSE
              READ MOVIME NEXT INTO REKMOV AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-MOV = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *
           IF KMV-AZI NOT = RG-CMC-AZI GO TO RNP-10.
           IF KMV-CON NOT = RG-CMC-CON GO TO RNP-10.
           IF MOV-DAT < DADATA GO TO RNP-10.
           IF ADATA NOT = ZERO
              IF MOV-DAT > ADATA GO TO RNP-10.
           IF MOV-FLAG NOT = ZERO GO TO RNP-10.

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-CMC-EOF.
           MOVE KEYMV TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-CMC-EOF.
           IF RG-CMC-EOF = 4 MOVE 2 TO RG-CMC-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-MOV = LOW-VALUE GO TO EX-TEST-EOL.
           IF (KMV-AZI = RG-CMC-AZI)
                              GO TO EX-TEST-EOL.
      *    IF (KMV-AZI = RG-CMC-AZI) AND 
      *       (KMV-CON = RG-CMC-CON) AND
      *       (ADATA = ZERO OR 
      *        (ADATA NOT = ZERO AND KMV-DAT < ADATA))
      *                       GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-CMC-AZI       TO KMV-AZI.
           MOVE RG-CMC-CON       TO KMV-CON.
           MOVE 1 TO TIPOP1.
           MOVE RG-CMC-DAT       TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG            TO KMV-DAT.
           MOVE RG-CMC-NUM       TO KMV-NUM.
      *
           MOVE RG-CMC-FLGPC     TO MOV-FLGPC.
           MOVE REKMOV TO RF-MOV.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE MOV-AZI       TO RG-CMC-AZI.
           MOVE MOV-CON       TO RG-CMC-CON.
      *
           MOVE 2             TO TIPOP1.
           MOVE MOV-DAT       TO AAGGG. 
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA        TO RG-CMC-DAT.
      *
           MOVE MOV-NUM       TO RG-CMC-NUM.
           MOVE MOV-CATT      TO RG-CMC-CATT.
           MOVE MOV-CAUS      TO RG-CMC-CAUS.
      *
           MOVE MOV-NDOC      TO RG-CMC-NDOC.
           MOVE MOV-DTDOC     TO AAGGG. 
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA        TO RG-CMC-DTDOC.
      *
           MOVE MOV-NPRGI     TO RG-CMC-NPRGI.
           MOVE MOV-NREG      TO RG-CMC-NREG.

           MOVE MOV-IVA       TO RG-CMC-IVA.
           IF MOV-TIP = 4 MOVE MOV-IML TO RG-CMC-IMP
           ELSE           MOVE MOV-IMP TO RG-CMC-IMP.
           MOVE MOV-TIP       TO RG-CMC-TIP.
           MOVE MOV-FLGPC     TO RG-CMC-FLGPC.
           MOVE MOV-FLGPC     TO SAV-FLGPC.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
      *    MOVE 3 TO KTB-TIP.
      *    MOVE MOV-IVA TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID 
      *         MOVE ALL '*' TO T03-DSIVA.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *    MOVE T03-DSIVA TO RA-CMC-DIVA-D.
      *
           MOVE SPACE     TO RA-CMC-CAUS-D.
           MOVE 2         TO KTB-TIP.
           MOVE MOV-CAUS  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE TAB-DESCR TO RA-CMC-CAUS-D.
      *
           MOVE MOV-AZI   TO KCF-AZI.
           MOVE MOV-ACF   TO KCF-COD.
           MOVE MOV-NDOC  TO RG-CMC-NDOC.
           READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS.
           MOVE CLF-RGS   TO RA-CMC-RGSOC-D.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-CMC-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-CON.
           MOVE 'CMC-CON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CON.
           IF RG-CMC-CON = ZERO
              PERFORM ERR-ZERO
      *******************************************************
      * Segnala "Dato obbligatorio".
      * L'utente potrebbe confermare l'inserimento senza aver
      * valorizzato la chiave.
      * Si scriverebbe un record con chiave a zero.
      *******************************************************
              GO TO V-ERROR.
       E-CON.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-CMC-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-FLGC.
           MOVE 'CMC-FLGPC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLGC.
           IF RG-CMC-FLGPC = 1 AND 
              SAV-FLGPC = ZERO

              MOVE MOV-DAT    TO AAGGG
              MOVE 2          TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE AA9 TO SAV-AA
              MOVE MM9 TO SAV-MM

              IF MM9 = 1
                  MOVE ZERO TO RG-CMC-FLGPC
                  MOVE 'Movimento del mese di Gennaio     ' 
                                                               TO F-MES1
                  MOVE 'Variazione competenza Iva non ammessa' TO F-MES2
                  MOVE 2 TO F-NMES
                  MOVE 'W' TO MB-TIPO
                  CALL 'vrmbox' USING PARMB
                  GO TO E-FLGC
              END-IF
              IF GG9 > 15
                  MOVE ZERO TO RG-CMC-FLGPC
                  MOVE 'Data  movimento superiore al 15 del mese' 
                                                               TO F-MES1
                  MOVE 'Variazione competenza Iva non ammessa' TO F-MES2
                  MOVE 2 TO F-NMES
                  MOVE 'W' TO MB-TIPO
                  CALL 'vrmbox' USING PARMB
                  GO TO E-FLGC
              END-IF

              MOVE MOV-DTDOC  TO AAGGG
              MOVE 2          TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF AA9 = SAV-AA AND
                 MM9 = SAV-MM
                  MOVE ZERO TO RG-CMC-FLGPC
                  MOVE 'Mese documento uguale a mese movimento' 
                                                            TO F-MES1
                  MOVE 'Variazione competenza Iva non ammessa ' 
                                                            TO F-MES2
                  MOVE 2 TO F-NMES
                  MOVE 'W' TO MB-TIPO
                  CALL 'vrmbox' USING PARMB
                  GO TO E-FLGC
              END-IF

           END-IF.

           MOVE MOV-DAT    TO AAGGG
           MOVE 2          TO TIPOP1
           CALL 'rdata' USING PARCDT
           MOVE AA9        TO SAV-AA
           MOVE MM9        TO SAV-MM

           MOVE DTINI      TO AAGGG
           MOVE 2          TO TIPOP1
           CALL 'rdata' USING PARCDT
           IF MM9 = (SAV-MM - 1)
               MOVE SAV-FLGPC TO RG-CMC-FLGPC
               MOVE "Registro IVA gia' stampato in definitivo"
                                                         TO F-MES1
               MOVE "Variazione competenza Iva non ammessa " 
                                                         TO F-MES2
               MOVE 2 TO F-NMES
               MOVE 'W' TO MB-TIPO
               CALL 'vrmbox' USING PARMB
               GO TO E-FLGC
           END-IF.

       E-FLGC.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       AGG-REG.
      *
           MOVE ZERO          TO PARVMOV.
           MOVE 'R'           TO PMV-FUN.
           MOVE MOV-AZI       TO PMV-AZI.
           MOVE MOV-NREG      TO PMV-NREG.
           MOVE MOV-DAT       TO PMV-DREG.
           MOVE MOV-FLGPC     TO PMV-FLAG.
           MOVE RG-CMC-FL     TO PMV-FL.
      *
           CALL 'varmov'   USING PARVMOV.
      *
       EX-AGG-REG.
           EXIT.
      *------------------
       CALL-VSRV133-MOV.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'MOV'   TO PPAR-TARC.
           MOVE KEYMV   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           IF ID-MOV = 'movime' MOVE '0' TO PPAR-OPZ(81:1).
           IF ID-MOV = 'movmol' MOVE '1' TO PPAR-OPZ(81:1).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 MOV. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
