       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON430.
      *
      * OGGETTO   :  PROGRAMMA VARIAZIONE MESE COMPETENZA FATTURE
      *
      **** rel 4.0
      * ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
       01  RELPRIMULA.
           05 FILLER PIC X(50) VALUE
              '@(#)Primula NT rel 4.0     GR Informatica'.
           05 FILLER PIC X     VALUE LOW-VALUE.
           COPY 'griazirk'.
           COPY 'gritabrk'.   
           COPY 'grit25rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 DAT1.
              10 GG1 PIC 99 VALUE ZERO.
              10 MM1 PIC 99 VALUE ZERO.
              10 AA1 PIC 99 VALUE ZERO.
           05 DAT2.
              10 GG2 PIC 99 VALUE ZERO.
              10 MM2 PIC 99 VALUE ZERO.
              10 AA2 PIC 99 VALUE ZERO.
           05 DT1 PIC 9(5)   COMP-3.
           05 DT2 PIC 9(5)   COMP-3.
           05 DTINI PIC 9(5)   COMP-3.
           05 DTAPE PIC 9(5) COMP-3.
           05 ZCON  PIC 9(7) COMP-3.
           05 N     PIC 999 VALUE ZERO.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-ZCON      PIC 9(7).
           05 IF-DATA-1    PIC 9(6).
           05 IF-DATA-2    PIC 9(6).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon430: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-CIVAQ TO ZCON.
      *     
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
                       PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
      *
           IF AZI-DTAPE = ZERO 
                 MOVE 'Manca data apertura esercizio' TO MESS
                 GO TO ERRIO.
           MOVE AZI-DTAPE TO DTAPE.
           IF T25-ESE = 1 MOVE AZI-DTAPE TO AAGGG
                          MOVE 2 TO TIPOP1
                          CALL 'rdata' USING PARCDT
                          MOVE 1 TO GG9
                          MOVE 1 TO MM9
                          MOVE 1 TO TIPOP1
                          CALL 'rdata' USING PARCDT
                          MOVE AAGGG TO DTAPE.

           IF T25-DUP = ZERO MOVE DTAPE TO AAGGG
           ELSE MOVE T25-DUP TO AAGGG
                ADD 1 TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           ADD 1 TO MM9.
           IF MM9 > 12
              MOVE 1 TO GG9
              MOVE 1 TO MM9
              ADD  1 TO AA9.
           MOVE GGMMAA TO IF-DATA-1.

           MOVE 1         TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           MOVE AAGGG     TO DTINI.

           MOVE ZERO   TO IF-DATA-2.
           MOVE ZCON   TO IF-ZCON.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DT1.
           IF DT1 < DTAPE
              MOVE 'Data anteriore a quella di apertura' TO MESS
              GO TO V-ERROR.
           IF DT1 < DTINI
              MOVE 'Data anteriore a stampa definitiva' TO F-MES1
              MOVE 'registri IVA.'                      TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DT2.
           IF DT1 > DT2 
              PERFORM ERR-DINC
              GO TO V-ERROR.
           IF (DT2 > T25-DUP) AND (DT1 NOT > T25-DUP)
              MOVE 'Date  incongruenti  rispetto a  data' TO F-MES1
              MOVE 'aggiornamento totali IVA progressivi' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
           MOVE IF-DATA-1 TO DAT1.
           MOVE IF-DATA-2 TO DAT2.
           IF AA1 NOT = AA2 
              PERFORM ERR-DINV
              GO TO V-ERROR.
      **** rel 7.2
      *    MOVE DT2 TO AAGGG.
      *    MOVE 2 TO TIPOP1.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE 1 TO TIPOP1.
      *    MOVE 31 TO GG9.
      *LPROS-10.
      *    CALL 'rdata' USING PARCDT.
      *    IF SWRET1 NOT = ZERO SUBTRACT 1 FROM GG9 GO TO LPROS-10.
      *    MOVE AAGGG TO DT2.
      *    MOVE GGMMAA TO IF-DATA-2 DAT2.
      *    MOVE ZERO TO N.
      *    SUBTRACT MM1 FROM MM2 GIVING N.
      *    IF (T25-PER = 0 AND N > 0) OR
      *       (T25-PER > 0 AND N > 2) 
      *       MOVE ZERO TO N 
      *       MOVE 'Periodo errato' TO MESS
      *       GO TO V-ERROR.
      *    MOVE ZERO TO N.
      *    IF T25-PER > ZERO 
      *       IF NOT (MM2 = 3 OR 6 OR 9 OR 12)
      *       MOVE 'Periodo errato' TO MESS
      *       GO TO V-ERROR.
      ************
       E-DATA-2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
      **** rel 7.2
      ************
       EX-RUN-ELABORA.
           EXIT.
      *------------------
