       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON142.
      *
      * Calcolo liquidazioni IVA
      *
      * Il file di lavoro WDS142 generato, viene poi utilizzato
      *                                              da vcon143
      * Viene cancellato da vcon140 o da vcon190
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'grimovsl'.
           COPY 'grimolsl'.
           COPY 'grimvxsl'.
           COPY 'grimmosl'.
           COPY 'griivasl'.
           COPY 'gritabsl'.
           COPY 'griivtsl'.
           COPY 'gri142sl'.
      **** rel 4.1a
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'grimov'.
           COPY 'grimvx'.
           COPY 'grimol'.
           COPY 'grimmo'.
           COPY 'griiva'.
           COPY 'griivt'.
           COPY 'gritab'.
      * file di lavoro usato poi da vcon143
           COPY 'gri142'.
      **** rel 4.1a
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 32 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
             05 KLV-AZI   PIC 9(3).
             05 KLV-COD   PIC 999.
           02 REKLAV.
             05 LAV-AVEN  PIC S9(11)V99.
             05 LAV-PAVE  PIC S9(11)V99.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'grit35rk'.
           COPY 'grit25rk'.
           COPY 'grimovrk'.
           COPY 'griivark'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MVX PIC X(15) VALUE 'movmxx'.
       01  ID-MOL PIC X(15) VALUE 'movmol'.
       01  ID-MMO PIC X(15) VALUE 'movoxx'.
       01  ID-IVT PIC X(15) VALUE 'movivt'.
       01  ID-142 PIC X(15) VALUE 'wds142'.
      **** rel 4.1a
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
      ************
       01  COMODI.
           05 SF-TAB    PIC XX.
           05 SF-MOV    PIC XX.
           05 SF-MVX    PIC XX.
           05 SF-MOL    PIC XX.
           05 SF-MMO    PIC XX.
           05 SF-IVT    PIC XX.
           05 SF-142    PIC XX.
           05 SF-IVA    PIC XX.
      **** rel 4.1a
           05 SF-LAV   PIC XX.
      ************
           05 MESS      PIC X(40)    VALUE SPACE.
           05 COM-FLVEN PIC 9        VALUE ZERO.
           05 CIVA      PIC 9(7) COMP-3.
           05 CIVAV     PIC 9(7) COMP-3 VALUE ZERO.
           05 COMO-CAL  PIC 999V99   VALUE ZERO.
      **** rel 4.0
      *    05 IMPOSTA   PIC S9(13)   VALUE ZERO.
      *    05 IMPOSC    PIC S9(13)   VALUE ZERO.
      *    05 IMPON     PIC S9(13)   VALUE ZERO.
      *    05 IMPONC    PIC S9(13)   VALUE ZERO.
           05 IMPOSTA   PIC S9(11)V99 VALUE ZERO.
           05 IMPON     PIC S9(11)V99 VALUE ZERO.
           05 IMPONC    PIC S9(11)V99 VALUE ZERO.
      ************
           05 COD       PIC 9(3)     VALUE ZERO.
           05 T25PER    PIC 9        VALUE ZERO.
           05 T25ATT    PIC 9        VALUE ZERO.
           05 T25PRI    PIC 9(3)V99  VALUE ZERO.
           05 PRI       PIC 9(3)V99  VALUE ZERO.
      **** rel 4.0-1
           05 T35PRI   PIC 9(3)V99   VALUE ZERO.
           05 T25DEP   PIC 9(3)V99   VALUE ZERO.
           05 T35DEP   PIC 9(3)V99   VALUE ZERO.
           05 DEP      PIC S9(12)V99 OCCURS 8.
      ************
      **** rel 4.0-2
           05 T25IND   PIC 9(7)     VALUE ZERO.
      ************
      **** NT 7.1
      *    05 K         PIC 99       VALUE ZERO.
      *    05 K1        PIC 99       VALUE ZERO.
      *    05 K2        PIC 99       VALUE ZERO.
      *    05 K3        PIC 99       VALUE ZERO.
      *    05 K4        PIC 99       VALUE ZERO.
           05 K         PIC 9(4)     VALUE ZERO.
           05 K1        PIC 9(4)     VALUE ZERO.
           05 K2        PIC 9(4)     VALUE ZERO.
           05 K3        PIC 9(4)     VALUE ZERO.
           05 K4        PIC 9(4)     VALUE ZERO.
      **********
           05 CALPERC   PIC 999V999  VALUE ZERO.
           05 COMPERC   PIC 999V99   VALUE ZERO.
           05 TOTPERC   PIC 999V99   VALUE ZERO.
      **** rel 4.0
      *    05 COMINCAS  PIC S9(12)   VALUE ZERO.
      *    05 COMIVAC   PIC S9(11)   VALUE ZERO.
      *    05 TOTCVEN   PIC S9(13)   VALUE ZERO.
      *    05 TOTINC    PIC S9(13)   VALUE ZERO.
      *    05 TOTIVAC   PIC S9(11)   VALUE ZERO.
      *    05 DIFFER    PIC S9(11)   VALUE ZERO.
      *    05 TGIVAC    PIC S9(12)   VALUE ZERO.
      *    05 TOTCOR    PIC S9(13)   VALUE ZERO.
           05 COMINCAS  PIC S9(11)V99 VALUE ZERO.
           05 COMIVAC   PIC S9(11)V99 VALUE ZERO.
           05 TOTCVEN   PIC S9(11)V99 VALUE ZERO.
           05 TOTINC    PIC S9(11)V99 VALUE ZERO.
           05 TOTIVAC   PIC S9(11)V99 VALUE ZERO.
           05 DIFFER    PIC S9(11)V99 VALUE ZERO.
           05 TGIVAC    PIC S9(11)V99 VALUE ZERO.
           05 TOTCOR    PIC S9(11)V99 VALUE ZERO.
      ************
           05 FLCATT    PIC 9        VALUE ZERO.
           05 COMCATT   PIC X        VALUE '0'.
      **** rel 4.0
      *    05 TOT12     PIC S9(13).
      *    05 TOT13     PIC S9(13).
      *    05 INDEP     PIC S9(12)   OCCURS 8.
           05 TOT12     PIC S9(11)V99.
           05 TOT13     PIC S9(11)V99.
           05 INDEP     PIC S9(11)V99 OCCURS 8.
      ************
      **** rel 4.0-1
           05 TOT14     PIC S9(11)V99.
      ************
           05 MATRICE.
      **** NT 7.1
      *       10 CDIVA PIC 9(3)   OCCURS 50.
              10 CDIVA PIC 9(3)   OCCURS 999.
      **********
      **** rel 4.0
      **** NT 7.1
      *       10 ACQVE PIC S9(11)V99 OCCURS 50.
              10 ACQVE PIC S9(11)V99 OCCURS 999.
      **********
      *       10 ACQVE PIC S9(13) OCCURS 50.
      ************
      **** rel 5.1
           05 DT3      PIC 9(5) COMP-3.
      ************
       LINKAGE SECTION.
      * parametri per vcon142
       01  PARLINK-142.
           05 ID-IVA PIC X(15).
           05 ID-TAB PIC X(15).
       COPY 'pariv'.
       PROCEDURE DIVISION USING PARLINK-142 PARIV.
           COPY 'declxer1'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dclmmo'.
           COPY 'dclmol'.
           COPY 'dclivt'.
           COPY 'dcliva'.
           COPY 'dcltab'.
           COPY 'dcl142'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDS142.
           CLOSE WDS142.
           OPEN  I-O WDS142.
      **** rel 4.1a
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN  I-O WDSLAV.
      ************
           OPEN INPUT TABELL
                      TOTIVA
                      MOVIME
                      MOVOXX
                      MOVMOL
                      MOVMXX
                      MOVIVT.
           MOVE ZERO TO TIPOP1 GGMMAA.
           CALL 'rdata' USING PARCDT.
      *
           MOVE ZERO TO IV-TIMPOV IV-TIVAV  IV-TIMPOA IV-TIVAA
                        IV-TINDA  IV-TINCAC IV-TIMPOC IV-TIVACO
                        IV-TULDET IV-TINDEP TOT12 TOT13 TGIVAC.
      **** rel 4.0-1
           MOVE ZERO TO TOT14.
      ************
           MOVE 25      TO T25-TIP.
           MOVE IV-CDAZ TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-ATT TO T25ATT.
      **** rel 4.0-1
      *    MOVE T25-PRI TO T25PRI.
           MOVE T25-PRI TO T25DEP.
      **** rel 4.0-2
      *    IF T25-PRI = ZERO MOVE ZERO TO T25PRI
      *    ELSE              COMPUTE T25PRI = 100 - T25DEP.
           MOVE T25-IND TO T25IND.
           IF T25-PRI = ZERO AND T25IND = ZERO
              MOVE ZERO TO T25PRI
           ELSE
              COMPUTE T25PRI = 100 - T25DEP.
      ************
      ************
           MOVE 25      TO T25-TIP.
           MOVE IV-CDAZ TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-PER TO T25PER.
      **** rel 5.1
           MOVE IV-DTFIK TO DT3.
      ************
      **** rel 7.2
           COMPUTE DT3 = IV-DTFIK + 15.
      ************
      *
           MOVE ZERO TO IV-DTPK.
      **** rel 4.1a
           MOVE LOW-VALUE TO KEYLV.
           MOVE IV-CDAZ TO KLV-AZI.
           MOVE ZERO    TO KLV-COD.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO LIQ15.
       LIQ10.
           READ WDSLAV NEXT AT END GO TO  LIQ15.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LIQ10.
           DELETE WDSLAV.
           GO TO LIQ10.
       LIQ15.
      ************
           MOVE IV-CDAZ TO K142-AZI.
           MOVE '0'     TO K142-CATT.
           MOVE ZERO    TO K142-COD.
           START WDS142 KEY NOT < KEY142 INVALID GO TO LIQ30.
       LIQ20.
           READ WDS142 NEXT AT END GO TO  LIQ30.
           IF SF-142 = '9D' OR '9A' OR '35' GO TO LIQ20.
           DELETE WDS142.
           GO TO LIQ20.
       LIQ30.
           PERFORM AGGIOR THRU EX-AGGIOR.
           MOVE ZERO TO IV-INDEP0 TOT12.
      **** rel 4.0-1
           MOVE ZERO TO IV-DEP0 TOT14.
      ************
           MOVE IV-DTPK TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE ZERO TO IV-IVAULT.
           MOVE ZERO TO IV-IVAVEN IV-IVAACQ IV-IVAIND IV-IVACOR
                        TOTCOR TOTCVEN K1.
           MOVE ZERO TO IV-TIMPOV IV-TIVAV  IV-TIMPOA IV-TIVAA
                        IV-TINDA  IV-TINCAC IV-TIMPOC IV-TIVACO
                        IV-TULDET IV-TINDEP IV-INDEP0.
       LOPCAR.
           ADD 1 TO K1.
      **** NT 7.1
      *    IF K1 > 50 GO TO LOPST-0.
           IF K1 > 999 GO TO LOPST-0.
      **********
           MOVE ZERO TO CDIVA(K1)
                        ACQVE(K1)
                        IV-CDIVAC(K1)
                        IV-IMPCOR(K1)
                        IV-INCASC(K1)
                        IV-IVAC(K1).
           IF K1 NOT > 8 MOVE ZERO TO INDEP(K1).
      **** rel 4.0-1
           IF K1 NOT > 8 MOVE ZERO TO DEP(K1).
      ************
           MOVE ZERO TO IV-CDIVAL(K1) IV-IMPOV(K1) IV-IVAV(K1)
                        IV-IMPOA(K1)  IV-IVAA(K1)  IV-INDA(K1)
                        IV-INCAC(K1)  IV-IMPOC(K1) IV-IVACO(K1)
                        IV-ULDET(K1)  IV-ULDE2(K1).
           GO TO LOPCAR.
       LOPST-0.
           MOVE ZERO TO FLCATT.
           MOVE IV-CDAZ TO K142-AZI.
           MOVE '0'     TO K142-CATT COMCATT.
           MOVE 1       TO K142-COD.
           START WDS142 KEY NOT < KEY142 INVALID GO TO FINEVIS.
       LOPST.
           READ WDS142 NEXT AT END
                MOVE ZERO TO FLCATT
                GO TO FINEVIS.
           IF SF-142 = '9D' OR '9A' OR '35' GO TO LOPST.
           IF K142-AZI > IV-CDAZ
              MOVE ZERO TO FLCATT
              GO TO FINEVIS.
           IF K142-CATT NOT = COMCATT
              MOVE 1 TO FLCATT
              GO TO FINEVIS.
       LOPCAR-0.
           IF K142-COD = 999
              ADD L142-CORR TO TOTCOR
              GO TO LOPST.
           MOVE 3       TO KTB-TIP.
           MOVE K142-COD TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF L142-AVEN = ZERO AND L142-PAVE = ZERO GO TO LOPCAR1.
           IF T03-ALVEN = ZERO
              MOVE K142-COD TO COD
           ELSE
              MOVE T03-ALVEN TO COD.
           MOVE ZERO TO K1.
       LOPCAR0.
           ADD 1 TO K1.
      **** NT 7.1
      *    IF K1 > 50 GO TO LOPST.
           IF K1 > 999 GO TO LOPST.
      **********
           IF CDIVA(K1) = ZERO
              MOVE COD      TO CDIVA(K1)
              ADD L142-AVEN TO ACQVE(K1) TOTCVEN
              ADD L142-PAVE TO ACQVE(K1) TOTCVEN
              GO TO LOPCAR1.
           IF CDIVA(K1) = COD
              ADD L142-AVEN TO ACQVE(K1) TOTCVEN
              ADD L142-PAVE TO ACQVE(K1) TOTCVEN
              GO TO LOPCAR1.
           GO TO LOPCAR0.
       LOPCAR1.
           MOVE ZERO TO K4.
       LOPCAR11.
           ADD 1 TO K4.
      **** NT 7.1
      *    IF K4 > 50 GO TO FINEVIS.
           IF K4 > 999 GO TO FINEVIS.
      **********
           IF IV-CDIVAL(K4) = ZERO
              MOVE K142-COD TO IV-CDIVAL(K4).
           IF IV-CDIVAL(K4) NOT = K142-COD GO TO LOPCAR11.
           ADD L142-VIMP TO IV-IMPOV(K4).
           ADD L142-VIVA TO IV-IVAV(K4) IV-IVAVEN.
           ADD L142-AIMP TO IV-IMPOA(K4).
      **** rel 4.0-1
      *    ADD L142-AIVA TO IV-IVAA(K4) IV-IVAACQ TOT12.
           ADD L142-AIVA TO IV-IVAA(K4) IV-IVAACQ TOT12 TOT14.
      ************
           ADD L142-AIVN TO IV-INDA(K4) IV-IVAIND.
           IF T03-ULDET > ZERO AND L142-AIMP > ZERO
      **** rel 4.0
      *       COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDET) / 100) + 0,49
              COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDET) / 100) + 0,0049
      ************
              ADD IMPOSTA TO IV-IVAULT IV-ULDET(K4).
           IF T03-ULDET > ZERO AND L142-AIMP < ZERO
      **** rel 4.0
      *       COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDET) / 100) - 0,49
              COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDET) / 100) - 0,0049
      ************
              ADD IMPOSTA TO IV-IVAULT IV-ULDET(K4).
           IF T03-ULDE2 > ZERO AND L142-AIMP > ZERO
      **** rel 4.0
      *       COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDE2) / 100) + 0,49
              COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDE2) / 100) + 0,0049
      ************
              ADD IMPOSTA TO IV-IVAULT IV-ULDE2(K4).
           IF T03-ULDE2 > ZERO AND L142-AIMP < ZERO
      **** rel 4.0
      *       COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDE2) / 100) - 0,49
              COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDE2) / 100) - 0,0049
      ************
              ADD IMPOSTA TO IV-IVAULT IV-ULDE2(K4).
           IF L142-CORR = ZERO GO TO LOPST.
           ADD L142-CORR TO IV-INCAC(K4).
           COMPUTE COMO-CAL = (100 + T03-ALIVA) / 100.
           COMPUTE IMPON = L142-CORR / COMO-CAL.
           ADD IMPON TO IV-IMPOC(K4).
           COMPUTE IMPOSTA = L142-CORR - IMPON.
           ADD IMPOSTA TO IV-IVACOR IV-IVACO(K4).
           GO TO LOPST.
       FINEVIS.
           MOVE ZERO TO K1 COMPERC COMINCAS TOTINC
                           TOTPERC COMIVAC TOTIVAC.
      **** rel 4.1a
      *    IF ACQVE(1) = ZERO GO TO FINEVI1.
      *FINEVI0.
      *    ADD 1 TO K1.
      *    IF K1 > 50 GO TO FINEVI1.
      *    IF ACQVE(K1) = ZERO GO TO FINEVI1.
      *    MOVE 3         TO KTB-TIP.
      *    MOVE CDIVA(K1) TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
      *                                    GO TO ERRIO.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *    COMPUTE CALPERC = (ACQVE(K1) * 100) / TOTCVEN.
      *    ADD 0,005    TO CALPERC.
      *    MOVE CALPERC TO COMPERC.
      *    ADD COMPERC  TO TOTPERC.
      *    COMPUTE K2 = K1 + 1.
      *    IF CDIVA(K2) = ZERO
      *       COMPUTE DIFFER = 100 - TOTPERC
      *       ADD DIFFER TO COMPERC
      *       COMPUTE COMINCAS = TOTCOR - TOTINC
      *    ELSE
      *       COMPUTE COMINCAS = (TOTCOR * COMPERC) / 100.
      *    ADD COMINCAS TO TOTINC.
      *    COMPUTE COMO-CAL = (100 + T03-ALIVA) / 100.
      *    COMPUTE IMPONC = COMINCAS / COMO-CAL.
      *    COMPUTE COMIVAC = COMINCAS - IMPONC.
      *    ADD COMIVAC TO TOTIVAC IV-IVACOR.
      *    MOVE ZERO TO K3.
      *FINEVI03.
      *    ADD 1 TO K3.
      *    IF K3 > 50 GO TO FINEVI0.
      *    IF IV-CDIVAC(K3) = ZERO
      *       MOVE CDIVA(K1) TO IV-CDIVAC(K3)
      *       MOVE COMINCAS  TO IV-INCASC(K3)
      *       MOVE IMPONC    TO IV-IMPCOR(K3)
      *       MOVE COMIVAC   TO IV-IVAC(K3)
      *       GO TO FINEVI0.
      *    IF IV-CDIVAC(K3) = CDIVA(K1)
      *           ADD COMINCAS TO IV-INCASC(K3)
      *           ADD IMPONC   TO IV-IMPCOR(K3)
      *           ADD COMIVAC  TO IV-IVAC(K3)
      *           GO TO FINEVI0.
      *    GO TO FINEVI03.
      *FINEVI1.

           PERFORM LOOP-LAV THRU EX-LOOP-LAV.
           IF TOTCVEN = ZERO GO TO FINEVI1.

           MOVE ZERO TO K2.
           MOVE LOW-VALUE TO KEYLV.
           MOVE IV-CDAZ   TO KLV-AZI.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO FINEVI1.
       RDNX.
           READ WDSLAV NEXT AT END GO TO FINEVI1.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RDNX.

           ADD 1 TO K2.
           MOVE ZERO TO ACQVE(1).

           MOVE 3         TO KTB-TIP.
           MOVE KLV-COD   TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.

           ADD LAV-PAVE TO LAV-AVEN GIVING ACQVE(1).

           COMPUTE CALPERC = (ACQVE(1) * 100) / TOTCVEN.
           ADD 0,005    TO CALPERC.
           MOVE CALPERC TO COMPERC.
           ADD COMPERC  TO TOTPERC.

           IF K2 = K1
              COMPUTE DIFFER = 100 - TOTPERC
              ADD DIFFER TO COMPERC
              COMPUTE COMINCAS = TOTCOR - TOTINC
           ELSE
              COMPUTE COMINCAS = (TOTCOR * COMPERC) / 100.
           ADD COMINCAS TO TOTINC.
           COMPUTE COMO-CAL = (100 + T03-ALIVA) / 100.
           COMPUTE IMPONC = COMINCAS / COMO-CAL.
           COMPUTE COMIVAC = COMINCAS - IMPONC.
           ADD COMIVAC TO TOTIVAC IV-IVACOR.
           MOVE ZERO TO K3.
       FINEVI03.
           ADD 1 TO K3.
      **** NT 7.1
      *    IF K3 > 50 GO TO RDNX.
           IF K3 > 999 GO TO RDNX.
      **********
           IF IV-CDIVAC(K3) = ZERO
              MOVE KLV-COD   TO IV-CDIVAC(K3)
              MOVE COMINCAS  TO IV-INCASC(K3)
              MOVE IMPONC    TO IV-IMPCOR(K3)
              MOVE COMIVAC   TO IV-IVAC(K3)
              GO TO RDNX.
           IF IV-CDIVAC(K3) = KLV-COD
                  ADD COMINCAS TO IV-INCASC(K3)
                  ADD IMPONC   TO IV-IMPCOR(K3)
                  ADD COMIVAC  TO IV-IVAC(K3)
                  GO TO RDNX.
           GO TO FINEVI03.
       FINEVI1.
      ************
           IF COMCATT = ZERO OR T25ATT = ZERO
              ADD TOT12 TO IV-INDEP0
      **** rel 4.0-1
              ADD TOT14 TO IV-DEP0
      ************
              GO TO FINEVI1-1.
           IF T35-GES = ZERO
              ADD TOT12 TO IV-INDEP0
      **** rel 4.0-1
              ADD TOT14 TO IV-DEP0
      ************
              GO TO FINEVI1-1.
      **** rel 4.0-1
           MOVE T35-PRI TO T35DEP.
           COMPUTE T35PRI = 100 - T35-PRI.
      ************
      **** rel 4.0-2
      *    IF T35-PRI NOT = ZERO MOVE COMCATT TO K
           IF T35-PRI NOT = ZERO OR T25IND NOT = ZERO
              MOVE COMCATT TO K
      ************
      **** rel 4.0-1
      *       COMPUTE INDEP(K) = ((TOT12 * T35-PRI) / 100).
              COMPUTE DEP (K)  = ((TOT14 * T35DEP) / 100)
              COMPUTE INDEP(K) = ((TOT12 * T35PRI) / 100).
      ************
       FINEVI1-1.
           MOVE ZERO TO TOT12.
           MOVE ZERO TO TOT13.
      **** rel 4.0-1
           MOVE ZERO TO TOT14.
      ************
           IF FLCATT = ZERO GO TO FINEVI11.
           MOVE ZERO TO K1 TOTCVEN TOTCOR FLCATT.
           MOVE K142-CATT TO T35-CATT.
           MOVE IV-CDAZ   TO T35-CDAZ.
           MOVE 35        TO T35-TIP.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                MOVE ZERO TO T35-GES T35-PRI.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE K142-CATT TO COMCATT.
       FINEVI10.
           ADD 1 TO K1.
      **** NT 7.1
      *    IF K1 > 50 GO TO LOPCAR-0.
           IF K1 > 999 GO TO LOPCAR-0.
      **********
           MOVE ZERO TO CDIVA(K1) ACQVE(K1).
           GO TO FINEVI10.
       FINEVI11.
      **** rel 4.0-2
      *    IF T25PRI = ZERO MOVE ZERO TO IV-INDEP0.
           IF T25PRI = ZERO AND T25IND = ZERO
              MOVE ZERO TO IV-INDEP0.
      ************
           IF IV-INDEP0 > ZERO
      **** rel 4.0
      *       COMPUTE IV-INDEP0 = ((IV-INDEP0 * T25PRI) / 100) + 0,49.
              COMPUTE IV-INDEP0 = ((IV-INDEP0 * T25PRI) / 100) + 0,0049.
      ************
           IF IV-INDEP0 < ZERO
      **** rel 4.0
      *       COMPUTE IV-INDEP0 = ((IV-INDEP0 * T25PRI) / 100) - 0,49.
              COMPUTE IV-INDEP0 = ((IV-INDEP0 * T25PRI) / 100) - 0,0049.
      ************
      **** rel 4.0-1
           IF IV-DEP0 > ZERO COMPUTE
                    IV-DEP0 = ( ( IV-DEP0 * T25DEP ) / 100 ) + 0,0049.
           IF IV-DEP0 < ZERO COMPUTE
                    IV-DEP0 = ( ( IV-DEP0 * T25DEP ) / 100 ) - 0,0049.
      ************
           MOVE ZERO TO K.
       FINEVI11-1.
           ADD 1 TO K.
           ADD INDEP(K) TO IV-INDEP0.
      **** rel 4.0-1
           ADD DEP(K) TO IV-DEP0.
      ************
           IF K < 8 GO TO FINEVI11-1.
           IF IV-CDCOR = ZERO
              MOVE ZERO TO IV-IVACOR
              GO TO FINEVI11-2.
           MOVE ZERO TO K.
       FINEVI11-10.
           ADD 1 TO K.
      **** NT 7.1
      *    IF K > 50 GO TO FINEVI11-2.
           IF K > 999 GO TO FINEVI11-2.
      **********
           IF IV-CDIVAC(K) = ZERO GO TO FINEVI11-2.
           MOVE ZERO TO K1.
       FINEVI11-15.
           ADD 1 TO K1.
      **** NT 7.1
      *    IF K1 > 50 GO TO FINEVI11-2.
           IF K1 > 999 GO TO FINEVI11-2.
      **********
           IF IV-CDIVAL(K1) = ZERO
              MOVE IV-CDIVAC(K) TO IV-CDIVAL(K1)
              MOVE IV-INCASC(K) TO IV-INCAC(K1)
              MOVE IV-IMPCOR(K) TO IV-IMPOC(K1)
              MOVE IV-IVAC(K)   TO IV-IVACO(K1)
              GO TO FINEVI11-10.
           IF IV-CDIVAL(K1) = IV-CDIVAC(K)
              ADD IV-INCASC(K) TO IV-INCAC(K1)
              ADD IV-IMPCOR(K) TO IV-IMPOC(K1)
              ADD IV-IVAC(K)   TO IV-IVACO(K1)
              GO TO FINEVI11-10.
           GO TO FINEVI11-15.
       FINEVI11-2.
           MOVE ZERO TO K1.
       FINEVI11-20.
           ADD 1 TO K1.
      **** NT 7.1
      *    IF K > 50 GO TO FINEVI11-3.
           IF K > 999 GO TO FINEVI11-3.
      **********
           IF IV-CDIVAL(K1) = ZERO GO TO FINEVI11-3.
           ADD IV-IMPOV(K1) TO IV-TIMPOV.
           ADD IV-IVAV(K1)  TO IV-TIVAV.
           ADD IV-IMPOA(K1) TO IV-TIMPOA.
           ADD IV-IVAA(K1)  TO IV-TIVAA.
           ADD IV-INDA(K1)  TO IV-TINDA.
           ADD IV-ULDET(K1) TO IV-TULDET.
           ADD IV-ULDE2(K1) TO IV-TULDET.
           ADD IV-INCAC(K1) TO IV-TINCAC.
           ADD IV-IMPOC(K1) TO IV-TIMPOC.
           ADD IV-IVACO(K1) TO IV-TIVACO.
           GO TO FINEVI11-20.
       FINEVI11-3.
           MOVE IV-INDEP0 TO IV-TINDEP.
      **** rel 3.0b
      **** rel 3.0a
      ** arrotondamenti come da Circolare Ministeriale
      ** del 9 Giugno 1999 n. 127/E
      *
      *    MOVE IV-DTINK TO AAGGG.
      *    MOVE 2 TO TIPOP1.
      *    CALL 'rdata' USING PARCDT.
      *    IF AA4 < 2000 GO TO FINEVI12.
      *
      *    ADD 499 TO IV-IVAVEN.
      *    COMPUTE IV-IVAVEN = IV-IVAVEN / 1000.
      *    COMPUTE IV-IVAVEN = IV-IVAVEN * 1000.
      *
      *    ADD 499 TO IV-IVAACQ.
      *    COMPUTE IV-IVAACQ = IV-IVAACQ / 1000.
      *    COMPUTE IV-IVAACQ = IV-IVAACQ * 1000.
      *
      *    ADD 499 TO IV-IVACOR.
      *    COMPUTE IV-IVACOR = IV-IVACOR / 1000.
      *    COMPUTE IV-IVACOR = IV-IVACOR * 1000.
      *
      *    ADD 499 TO IV-IVAULT.
      *    COMPUTE IV-IVAULT = IV-IVAULT / 1000.
      *    COMPUTE IV-IVAULT = IV-IVAULT * 1000.
      *
      *    ADD 499 TO IV-INDEP0.
      *    COMPUTE IV-INDEP0 = IV-INDEP0 / 1000.
      *    COMPUTE IV-INDEP0 = IV-INDEP0 * 1000.
      *
      *    ADD 499 TO IV-IVAIND.
      *    COMPUTE IV-IVAIND = IV-IVAIND / 1000.
      *    COMPUTE IV-IVAIND = IV-IVAIND * 1000.
      *FINEVI12.
      *************
      *************
           GO TO FINE.
      *------------------
       ERRIO.
           COPY 'errsub'.
       FINE.
           CLOSE TABELL TOTIVA.
           CLOSE MOVIME MOVOXX MOVMOL MOVMXX.
           CLOSE MOVIVT.
           CLOSE WDS142.
      **** rel 4.1a
           CLOSE WDSLAV.
      ************
           EXIT PROGRAM.
           STOP RUN.
           COPY 'errmes'.
           COPY 'grimover'.
           COPY 'griivter'.
           COPY 'gritaber'.
           COPY 'griivaer'.
           COPY 'grixxxer'.
      *------------------
       AGGIOR.
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-CIVAQ TO CIVA.
           MOVE T01-CIVAV TO CIVAV.
           MOVE 1  TO KTB-COD.
           MOVE 14 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-CDCOR TO IV-CDCOR.
           IF IV-TSDAT = 2
              PERFORM B00-AGG-LA1 THRU B99
              GO TO EX-AGGIOR.
           IF IV-CDCOR = ZERO GO TO LPIV.
           IF IV-TSDAT = ZERO
              PERFORM A00-AGG-ACQ THRU A99
           ELSE
              PERFORM B00-AGG-LA1 THRU B99.
       LPIV.
           MOVE IV-CDAZ  TO KMO-AZI.
           MOVE CIVA     TO KMO-CON.
           MOVE IV-DTINK TO KMO-DAT.
           MOVE ZERO     TO KMO-NUM.
           START MOVOXX KEY NOT < KEYMO INVALID GO TO LPIV-10.
       RDMMO.
           READ MOVOXX NEXT INTO REKMOV AT END GO TO LPIV-10.
           IF SF-MMO = '9D' OR '9A' OR '35' GO TO RDMMO.
           IF KMO-AZI > IV-CDAZ  GO TO LPIV-10.
           IF KMO-CON > CIVA     GO TO LPIV-10.
      **** rel 5.1
      *    IF KMO-DAT > IV-DTFIK GO TO LPIV-10.
           IF KMO-DAT > DT3  GO TO LPIV-10.
           IF KMO-DAT < IV-DTFIK
              IF MOV-FLGPC > ZERO GO TO RDMMO.
           IF KMO-DAT > IV-DTFIK
              IF MOV-FLGPC = ZERO GO TO RDMMO.
      ************
           IF MOV-FLAG = 1 GO TO RDMMO.
           IF (CIVA NOT = CIVAV) OR (T25PER NOT = 2)
              PERFORM RAGG THRU EX-RAGG
              GO TO RDMMO.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TSOPE NOT = 7
              GO TO RDMMO
           ELSE
              PERFORM RAGG THRU EX-RAGG
              GO TO RDMMO.
       LPIV-10.
           MOVE IV-CDAZ  TO KML-AZI.
           MOVE CIVA     TO KML-CON.
           MOVE IV-DTINK TO KML-DAT.
           MOVE ZERO     TO KML-NUM.
           START MOVMOL KEY NOT < KEYML INVALID GO TO LPIV-20.
       RDMOL.
           READ MOVMOL NEXT INTO REKMOV AT END GO TO LPIV-20.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO RDMOL.
           IF KML-AZI > IV-CDAZ  GO TO LPIV-20.
           IF KML-CON > CIVA     GO TO LPIV-20.
      **** rel 5.1
      *    IF KML-DAT > IV-DTFIK GO TO LPIV-20.
           IF KML-DAT > DT3 GO TO LPIV-20.
           IF KML-DAT < IV-DTFIK
              IF MOV-FLGPC > ZERO GO TO RDMOL.
           IF KML-DAT > IV-DTFIK
              IF MOV-FLGPC = ZERO GO TO RDMOL.
      ************
           IF MOV-FLAG = 1 GO TO RDMOL.
           IF (CIVA NOT = CIVAV) OR (T25PER NOT = 2)
              PERFORM RAGG THRU EX-RAGG
              GO TO RDMOL.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TSOPE NOT = 7
              GO TO RDMOL
           ELSE
              PERFORM RAGG THRU EX-RAGG
              GO TO RDMOL.
       LPIV-20.
           MOVE IV-CDAZ  TO KMX-AZI.
           MOVE CIVA     TO KMX-CON.
           MOVE IV-DTINK TO KMX-DAT.
           MOVE ZERO     TO KMX-NUM.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO LPIV-30.
       RDMVX.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO LPIV-30.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO RDMVX.
           IF KMX-AZI > IV-CDAZ  GO TO LPIV-30.
           IF KMX-CON > CIVA     GO TO LPIV-30.
      **** rel 5.1
      *    IF KMX-DAT > IV-DTFIK GO TO LPIV-30.
           IF KMX-DAT > DT3 GO TO LPIV-30.
           IF KMX-DAT < IV-DTFIK
              IF MOV-FLGPC > ZERO GO TO RDMVX.
           IF KMX-DAT > IV-DTFIK
              IF MOV-FLGPC = ZERO GO TO RDMVX.
      ************
           IF MOV-FLAG = 1 GO TO RDMVX.
           IF (CIVA NOT = CIVAV) OR (T25PER NOT = 2)
              PERFORM RAGG THRU EX-RAGG
              GO TO RDMVX.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TSOPE NOT = 7
              GO TO RDMVX
           ELSE
              PERFORM RAGG THRU EX-RAGG
              GO TO RDMVX.
       LPIV-30.
           MOVE IV-CDAZ  TO KMV-AZI.
           MOVE CIVA     TO KMV-CON.
           MOVE IV-DTINK TO KMV-DAT.
           MOVE ZERO     TO KMV-NUM.
           START MOVIME KEY NOT < KEYMV INVALID GO TO ENDAG.
       RDMOV.
           READ MOVIME NEXT INTO REKMOV AT END GO TO ENDAG.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO RDMOV.
           IF KMV-AZI > IV-CDAZ  GO TO ENDAG.
           IF KMV-CON > CIVA     GO TO ENDAG.
      **** rel 5.1
      *    IF KMV-DAT > IV-DTFIK GO TO ENDAG.
           IF KMV-DAT > DT3 GO TO ENDAG.
           IF KMV-DAT < IV-DTFIK
              IF MOV-FLGPC > ZERO GO TO RDMOV.
           IF KMV-DAT > IV-DTFIK
              IF MOV-FLGPC = ZERO GO TO RDMOV.
      ************
           IF MOV-FLAG = 1 GO TO RDMOV.
           IF CIVA NOT = CIVAV GO TO R-AGG.
           IF T25PER NOT = 2   GO TO R-AGG.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TSOPE NOT = 7 GO TO RDMOV.
       R-AGG.
           PERFORM RAGG THRU EX-RAGG.
           GO TO RDMOV.
       ENDAG.
      **** rel 5.1
      *    IF CIVA NOT = CIVAV
      *       MOVE CIVAV TO CIVA
      *       GO TO LPIV.
           IF CIVA NOT = CIVAV
              MOVE CIVAV TO CIVA
      **** rel 7.2
      *        MOVE IV-DTFIK TO AAGGG
      *        MOVE 2 TO TIPOP1
      *        CALL 'rdata' USING PARCDT
      *        MOVE 1 TO TIPOP1
      ***** rel 5.1
      **       IF MM9 = 12 MOVE IV-DTFIK TO DT3
      **                   GO TO LPIV
      **       ELSE COMPUTE DT3 = IV-DTFIK + 15
      **            GO TO LPIV.
      *        COMPUTE DT3 = IV-DTFIK + 15
      *************
              GO TO LPIV.
      ************
      ************
           IF T25PER NOT = 2 GO TO AGGCORR.
           MOVE IV-CDAZ  TO KVT-AZI.
           MOVE CIVA     TO KVT-CON.
           MOVE IV-DTINK TO KVT-DAT.
           MOVE ZERO     TO KVT-NUM.
           START MOVIVT KEY NOT < KEYVT INVALID GO TO AGGCORR.
       RDIVT.
           READ MOVIVT NEXT INTO REKMOV AT END GO TO AGGCORR.
           IF SF-IVT = '9D' OR '9A' OR '35' GO TO RDIVT.
           IF KVT-AZI > IV-CDAZ  GO TO AGGCORR.
           IF KVT-CON > CIVA     GO TO AGGCORR.
      **** rel 5.1
      *    IF KVT-DAT > IV-DTFIK GO TO AGGCORR.
           IF KVT-DAT > DT3 GO TO AGGCORR.
           IF KVT-DAT < IV-DTFIK
              IF MOV-FLGPC > ZERO GO TO RDIVT.
           IF KVT-DAT > IV-DTFIK
              IF MOV-FLGPC = ZERO GO TO RDIVT.
      ************
           PERFORM RAGG THRU EX-RAGG.
           GO TO RDIVT.
       AGGCORR.
           MOVE ZERO TO K.
           IF IV-CDCOR = ZERO GO TO EX-AGGIOR.
       AGG-0.
           MOVE IV-CDAZ  TO KMO-AZI.
           MOVE IV-CDCOR TO KMO-CON.
           MOVE IV-DTINK TO KMO-DAT.
           MOVE ZERO TO KMO-NUM.
           START MOVOXX KEY NOT < KEYMO INVALID GO TO AGG-10.
       RDMMOC.
           READ MOVOXX NEXT INTO REKMOV AT END GO TO AGG-10.
           IF SF-MMO = '9D' OR '9A' OR '35' GO TO RDMMOC.
           IF KMO-AZI > IV-CDAZ  GO TO AGG-10.
           IF KMO-CON > IV-CDCOR GO TO AGG-10.
      **** rel 5.1
      *    IF KMO-DAT > IV-DTFIK GO TO AGG-10.
           IF KMO-DAT > DT3 GO TO AGG-10.
           IF KMO-DAT < IV-DTFIK
              IF MOV-FLGPC > ZERO GO TO RDMMOC.
           IF KMO-DAT > IV-DTFIK
              IF MOV-FLGPC = ZERO GO TO RDMMOC.
      ************
           PERFORM RAGGC THRU EX-RAGGC.
           GO TO RDMMOC.
       AGG-10.
           MOVE IV-CDAZ  TO KML-AZI.
           MOVE IV-CDCOR TO KML-CON.
           MOVE IV-DTINK TO KML-DAT.
           MOVE ZERO     TO KML-NUM.
           START MOVMOL KEY NOT < KEYML INVALID GO TO AGG-20.
       RDMOLC.
           READ MOVMOL NEXT INTO REKMOV AT END GO TO AGG-20.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO RDMOLC.
           IF KML-AZI > IV-CDAZ  GO TO AGG-20.
           IF KML-CON > IV-CDCOR GO TO AGG-20.
      **** rel 5.1
      *    IF KML-DAT > IV-DTFIK GO TO AGG-20.
           IF KML-DAT > DT3 GO TO AGG-20.
           IF KML-DAT < IV-DTFIK
              IF MOV-FLGPC > ZERO GO TO RDMOLC.
           IF KML-DAT > IV-DTFIK
              IF MOV-FLGPC = ZERO GO TO RDMOLC.
      ************
           PERFORM RAGGC THRU EX-RAGGC.
           GO TO RDMOLC.
       AGG-20.
           MOVE IV-CDAZ  TO KMX-AZI.
           MOVE IV-CDCOR TO KMX-CON.
           MOVE IV-DTINK TO KMX-DAT.
           MOVE ZERO     TO KMX-NUM.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO AGG-30.
       RDMVXC.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO AGG-30.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO RDMVXC.
           IF KMX-AZI > IV-CDAZ  GO TO AGG-30.
           IF KMX-CON > IV-CDCOR GO TO AGG-30.
      **** rel 5.1
      *    IF KMX-DAT > IV-DTFIK GO TO AGG-30.
           IF KMX-DAT > DT3 GO TO AGG-30.
           IF KMX-DAT < IV-DTFIK
              IF MOV-FLGPC > ZERO GO TO RDMVXC.
           IF KMX-DAT > IV-DTFIK
              IF MOV-FLGPC = ZERO GO TO RDMVXC.
      ************
           PERFORM RAGGC THRU EX-RAGGC.
           GO TO RDMVXC.
       AGG-30.
           MOVE IV-CDAZ  TO KMV-AZI.
           MOVE IV-CDCOR TO KMV-CON.
           MOVE IV-DTINK TO KMV-DAT.
           MOVE ZERO     TO KMV-NUM.
           START MOVIME KEY NOT < KEYMV INVALID GO TO EX-AGGIOR.
       RDMOVC.
           READ MOVIME NEXT INTO REKMOV AT END GO TO EX-AGGIOR.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO RDMOVC.
           IF KMV-AZI > IV-CDAZ  GO TO EX-AGGIOR.
           IF KMV-CON > IV-CDCOR GO TO EX-AGGIOR.
      **** rel 5.1
      *    IF KMV-DAT > IV-DTFIK GO TO EX-AGGIOR.
           IF KMV-DAT > DT3 GO TO EX-AGGIOR.
           IF KMV-DAT < IV-DTFIK
              IF MOV-FLGPC > ZERO GO TO RDMOVC.
           IF KMV-DAT > IV-DTFIK
              IF MOV-FLGPC = ZERO GO TO RDMOVC.
      ************
           PERFORM RAGGC THRU EX-RAGGC.
           GO TO RDMOVC.
       EX-AGGIOR.
           EXIT.
      *------------------
       RAGG.
           IF MOV-FLAG = 1 GO TO EX-RAGG.
           IF MOV-DAT > IV-DTPK MOVE MOV-DAT TO IV-DTPK.
           MOVE IV-CDAZ  TO K142-AZI.
           MOVE MOV-CATT TO K142-CATT.
           MOVE MOV-IVA  TO K142-COD.
       RAGG-00.
           READ WDS142 INVALID GO TO WRIVA.
           IF SF-142 = '9D' OR '9A' OR '35' GO TO RAGG-00.
      **** rel 4.1a
           MOVE IV-CDAZ  TO KLV-AZI.
           MOVE MOV-IVA  TO KLV-COD.
           READ WDSLAV INVALID MOVE ZERO TO LAV-AVEN.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RAGG-00.
      ************
           MOVE 2        TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T02-FLVEN TO COM-FLVEN.
           IF T02-TIPOP = 8
              COMPUTE MOV-IMPO = MOV-IMPO * -1
              IF MOV-TIP = 4
                 COMPUTE MOV-IML = MOV-IML * -1
                 COMPUTE MOV-INL = MOV-INL * -1
              ELSE
                 COMPUTE MOV-IMP = MOV-IMP * -1
                 COMPUTE MOV-IVN = MOV-IVN * -1.
           IF MOV-CON NOT = CIVAV GO TO RAGG-10.
           ADD MOV-IMPO TO L142-VIVA.
           IF MOV-TIP = 4
              ADD MOV-IML TO L142-VIMP
           ELSE
              ADD MOV-IMP TO L142-VIMP.
           GO TO RWIVA.
       RAGG-10.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           ADD MOV-IMPO TO L142-AIVA.
           IF MOV-TIP = 4
              ADD MOV-IML TO L142-AIMP
              GO TO RAGG-20.
           ADD MOV-IMP TO L142-AIMP.
       RAGG-20.
           IF T03-TPIVA NOT = ZERO GO TO RAGG-30.
           IF NOT (COM-FLVEN = 1 AND MOV-FEV = ZERO) GO TO RWIVA.
           ADD MOV-IMPO TO L142-AVEN.
           IF MOV-TIP = 4
              ADD MOV-IML TO L142-AVEN
           ELSE
              ADD MOV-IMP TO L142-AVEN.
      **** rel 4.1a
           ADD MOV-IMPO TO LAV-AVEN.
           IF MOV-TIP = 4
              ADD MOV-IML TO LAV-AVEN
           ELSE
              ADD MOV-IMP TO LAV-AVEN.
      ************
           GO TO RWIVA.
       RAGG-30.
           IF MOV-TIP = 4
              ADD MOV-INL TO L142-AIVN
           ELSE
              ADD MOV-IVN TO L142-AIVN.
       RWIVA.
           REWRITE RF-142 INVALID
                   MOVE 'vcon142: errore RWR.LA1' TO MESS
                   GO TO ERRIO.
      **** rel 4.1a
           REWRITE RF-LAV INVALID
                   MOVE 'vcon142: errore RWR.LAV' TO MESS
                   GO TO ERRIO.
      ************
           GO TO EX-RAGG.
       WRIVA.
           MOVE ZERO TO RF-142.
           MOVE ZERO TO L142-VIMP  L142-VIVA  L142-AIMP
                        L142-AIVA  L142-AIVN  L142-PVIMP
                        L142-PVIVA L142-PAIMP L142-PAIVA
                        L142-PAIVN L142-CORR  L142-PCOR
                        L142-IVCE  L142-IMCE  L142-AVEN
                        L142-PAVE.
           MOVE IV-CDAZ  TO K142-AZI.
           MOVE MOV-CATT TO K142-CATT.
           MOVE MOV-IVA  TO K142-COD.
           WRITE RF-142 INVALID
                 MOVE 'vcon142: errore WR.LA1' TO MESS
                 GO TO ERRIO.
      **** rel 4.1a
           MOVE IV-CDAZ TO KLV-AZI.
           MOVE MOV-IVA TO KLV-COD.
           READ WDSLAV  NOT INVALID GO TO RAGG-00.

           MOVE ZERO     TO RF-LAV.
           MOVE IV-CDAZ  TO KLV-AZI.
           MOVE MOV-IVA  TO KLV-COD.
           WRITE RF-LAV INVALID
                 MOVE 'vcon142: errore WR.LAV' TO MESS
                 GO TO ERRIO.
      ************
           GO TO RAGG-00.
       EX-RAGG.
           EXIT.
      *------------------
       RAGGC.
           IF MOV-FLAG = 1 GO TO EX-RAGGC.
           IF MOV-DAT > IV-DTPK MOVE MOV-DAT TO IV-DTPK.
           MOVE IV-CDAZ  TO K142-AZI.
           MOVE MOV-CATT TO K142-CATT.
           MOVE MOV-IVA  TO K142-COD.
       RAGGC-00.
           READ WDS142 INVALID GO TO WRCORR.
           IF SF-142 = '9D' OR '9A' OR '35' GO TO RAGGC-00.
           MOVE 2        TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF MOV-TREG = 2 AND T02-TIPOP = 8
              COMPUTE MOV-IMP = MOV-IMP * -1
              COMPUTE MOV-IVN = MOV-IVN * -1.
           ADD MOV-IMP TO L142-CORR.
           IF MOV-TREG = 2 ADD MOV-IVN TO L142-CORR.
           REWRITE RF-142 INVALID
                   MOVE 'vcon142: errore RWR.LA1' TO MESS
                   GO TO ERRIO.
           GO TO EX-RAGGC.
       WRCORR.
           MOVE ZERO TO RF-142.
           MOVE ZERO TO L142-VIMP  L142-VIVA  L142-AIMP
                        L142-AIVA  L142-AIVN  L142-PVIMP
                        L142-PVIVA L142-PAIMP L142-PAIVA
                        L142-PAIVN L142-CORR  L142-PCOR
                        L142-IVCE  L142-IMCE  L142-AVEN
                        L142-PAVE.
           MOVE IV-CDAZ  TO K142-AZI.
           MOVE MOV-CATT TO K142-CATT.
           MOVE MOV-IVA  TO K142-COD.
           WRITE RF-142 INVALID
                 MOVE 'vcon142: errore WR.LA1' TO MESS
                 GO TO ERRIO.
           GO TO RAGGC.
       EX-RAGGC.
           EXIT.
      *------------------
       B00-AGG-LA1.
           MOVE IV-CDAZ TO KIV-AZI.
           MOVE '0'     TO KIV-CATT.
           MOVE ZERO    TO KIV-COD.
           START TOTIVA KEY NOT < KEYIV INVALID GO TO B99.
       B10.
           READ TOTIVA NEXT INTO REKIVA AT END GO TO B99.
           IF SF-IVA = '9D' OR '9A' OR '35' MOVE RF-IVA TO REKIVA.
           IF KIV-AZI > IV-CDAZ GO TO B99.
           IF IV-TSDAT = 1 AND IVA-PAVE = ZERO GO TO B10.
           MOVE KEYIV TO KEY142.
           READ WDS142 INVALID GO TO B20.
      **** rel 4.1a
           MOVE IV-CDAZ  TO KLV-AZI.
           MOVE KIV-COD  TO KLV-COD.
           READ WDSLAV INVALID GO TO B20.
      ************
       B15.
      **** rel 7.1
      * Rimozione anomalia: durante stampa dava errore 153 
      * poich riportava anche i totalizzatori vuoti
           IF IVA-VIMP  = ZERO AND
              IVA-VIVA  = ZERO AND
              IVA-AIMP  = ZERO AND
              IVA-AIVA  = ZERO AND
              IVA-AIVN  = ZERO AND
              IVA-PVIMP = ZERO AND
              IVA-PVIVA = ZERO AND
              IVA-PAIMP = ZERO AND
              IVA-PAIVA = ZERO AND
              IVA-PAIVN = ZERO AND
              IVA-CORR  = ZERO AND
              IVA-PCOR  = ZERO AND
              IVA-AVEN  = ZERO AND
              IVA-PAVE  = ZERO AND
              IVA-IMCE  = ZERO AND
              IVA-IVCE  = ZERO
              GO TO B10.
      ************
           MOVE IVA-PAVE TO L142-PAVE.
      **** rel 4.1a
      **** rel 6.2
      *    MOVE IVA-PAVE TO LAV-PAVE.
           ADD  IVA-PAVE TO LAV-PAVE.
      ************
      ************
           IF IV-TSDAT = 2 MOVE IVA-PVIMP TO L142-VIMP
                           MOVE IVA-PVIVA TO L142-VIVA
                           MOVE IVA-PAIMP TO L142-AIMP
                           MOVE IVA-PAIVA TO L142-AIVA
                           MOVE IVA-PAIVN TO L142-AIVN
                           MOVE IVA-PCOR  TO L142-CORR.
           REWRITE RF-142 INVALID
                   MOVE 'vcon142: errore RWR.LA1' TO MESS
                   GO TO ERRIO.
      **** rel 4.1a
           REWRITE RF-LAV INVALID
                   MOVE 'vcon142: errore RWR.LAV' TO MESS
                   GO TO ERRIO.
      ************
           GO TO B10.
       B20.
           MOVE ZERO TO RF-142.
           MOVE ZERO TO L142-VIMP  L142-VIVA  L142-AIMP
                        L142-AIVA  L142-AIVN  L142-PVIMP
                        L142-PVIVA L142-PAIMP L142-PAIVA
                        L142-PAIVN L142-CORR  L142-PCOR
                        L142-IVCE  L142-IMCE  L142-AVEN
                        L142-PAVE.
           MOVE IV-CDAZ  TO K142-AZI.
           MOVE KIV-CATT TO K142-CATT.
           MOVE KIV-COD  TO K142-COD.
           WRITE RF-142 INVALID
                 MOVE 'vcon142: errore WR.LA1' TO MESS
                 GO TO ERRIO.
      **** rel 4.1a
           MOVE IV-CDAZ  TO KLV-AZI.
           MOVE KIV-COD  TO KLV-COD.
           READ WDSLAV NOT INVALID GO TO B15.

           MOVE ZERO TO RF-LAV.
           MOVE IV-CDAZ  TO KLV-AZI.
           MOVE KIV-COD  TO KLV-COD.
           WRITE RF-LAV INVALID
                 MOVE 'vcon142: errore WR.LAV' TO MESS
                 GO TO ERRIO.
      ************
           GO TO B15.
       B99.
           EXIT.
      *------------------
       A00-AGG-ACQ.
           MOVE IV-CDAZ  TO KMO-AZI.
           MOVE CIVA     TO KMO-CON.
           MOVE IV-DTAPE TO KMO-DAT.
           MOVE ZERO     TO KMO-NUM.
           START MOVOXX KEY NOT < KEYMO INVALID GO TO A20.
       A10.
           READ MOVOXX NEXT INTO REKMOV AT END GO TO A20.
           IF SF-MMO = '9D' OR '9A' OR '35' GO TO A10.
           IF KMO-AZI > IV-CDAZ      GO TO A20.
           IF KMO-CON > CIVA         GO TO A20.
           IF KMO-DAT NOT < IV-DTINK GO TO A20.
           PERFORM C00-AGG THRU C99.
           GO TO A10.
       A20.
           MOVE IV-CDAZ  TO KML-AZI.
           MOVE CIVA     TO KML-CON.
           MOVE IV-DTAPE TO KML-DAT.
           MOVE ZERO     TO KML-NUM.
           START MOVMOL KEY NOT < KEYML INVALID GO TO A40.
       A30.
           READ MOVMOL NEXT INTO REKMOV AT END GO TO A40.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO A30.
           IF KML-AZI > IV-CDAZ      GO TO A40.
           IF KML-CON > CIVA         GO TO A40.
           IF KML-DAT NOT < IV-DTINK GO TO A40.
           PERFORM C00-AGG THRU C99.
           GO TO A30.
       A40.
           MOVE IV-CDAZ  TO KMX-AZI.
           MOVE CIVA     TO KMX-CON.
           MOVE IV-DTAPE TO KMX-DAT.
           MOVE ZERO     TO KMX-NUM.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO A60.
       A50.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO A60.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO A50.
           IF KMX-AZI > IV-CDAZ      GO TO A60.
           IF KMX-CON > CIVA         GO TO A60.
           IF KMX-DAT NOT < IV-DTINK GO TO A60.
           PERFORM C00-AGG THRU C99.
           GO TO A50.
       A60.
           MOVE IV-CDAZ  TO KMV-AZI.
           MOVE CIVA     TO KMV-CON.
           MOVE IV-DTAPE TO KMV-DAT.
           MOVE ZERO     TO KMV-NUM.
           START MOVIME KEY NOT < KEYMV INVALID GO TO A99.
       A70.
           READ MOVIME NEXT INTO REKMOV AT END GO TO A99.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO A70.
           IF KMV-AZI > IV-CDAZ      GO TO A99.
           IF KMV-CON > CIVA         GO TO A99.
           IF KMV-DAT NOT < IV-DTINK GO TO A99.
           PERFORM C00-AGG THRU C99.
           GO TO A70.
       A99.
           EXIT.
      *------------------
       C00-AGG.
           IF MOV-FLAG = 1 GO TO C99.
           MOVE IV-CDAZ  TO K142-AZI.
           MOVE MOV-CATT TO K142-CATT.
           MOVE MOV-IVA  TO K142-COD.
       C10.
           READ WDS142 INVALID GO TO C40.
           IF SF-142 = '9D' OR '9A' OR '35' GO TO C10.
      **** rel 4.1a
           MOVE IV-CDAZ  TO KLV-AZI.
           MOVE MOV-IVA  TO KLV-COD.
           READ WDSLAV INVALID MOVE ZERO TO LAV-AVEN LAV-PAVE.
      ************
           MOVE 2        TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T02-FLVEN TO COM-FLVEN.
           IF T02-TIPOP = 8
              COMPUTE MOV-IMPO = MOV-IMPO * -1
              IF MOV-TIP = 4
                 COMPUTE MOV-IML = MOV-IML * -1
              ELSE
                 COMPUTE MOV-IMP = MOV-IMP * -1.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TPIVA NOT = ZERO GO TO C99.
           IF NOT (COM-FLVEN = 1 AND MOV-FEV = ZERO) GO TO C99.
           ADD MOV-IMPO TO L142-PAVE.
           IF MOV-TIP = 4
              ADD MOV-IML TO L142-PAVE
           ELSE
              ADD MOV-IMP TO L142-PAVE.
           REWRITE RF-142 INVALID
                   MOVE 'vcon142: errore RWR.LA1' TO MESS
                   GO TO ERRIO.
      **** rel 4.1a
           ADD MOV-IMPO TO LAV-PAVE.
           IF MOV-TIP = 4
              ADD MOV-IML TO LAV-PAVE
           ELSE
              ADD MOV-IMP TO LAV-PAVE.
           REWRITE RF-LAV INVALID
                   MOVE 'vcon142: errore RWR.LAV' TO MESS
                   GO TO ERRIO.
      ************
           GO TO C99.
       C40.
           MOVE ZERO TO RF-142.
           MOVE ZERO TO L142-VIMP  L142-VIVA  L142-AIMP
                        L142-AIVA  L142-AIVN  L142-PVIMP
                        L142-PVIVA L142-PAIMP L142-PAIVA
                        L142-PAIVN L142-CORR  L142-PCOR
                        L142-IVCE  L142-IMCE  L142-AVEN
                        L142-PAVE.
           MOVE IV-CDAZ  TO K142-AZI.
           MOVE MOV-CATT TO K142-CATT.
           MOVE MOV-IVA  TO K142-COD.
           WRITE RF-142 INVALID
                 MOVE 'vcon142: errore WR.LA1' TO MESS
                 GO TO ERRIO.
      **** rel 4.1a
           MOVE IV-CDAZ TO KLV-AZI.
           MOVE MOV-IVA TO KLV-COD.
           READ WDSLAV  NOT INVALID GO TO C10.

           MOVE ZERO TO RF-LAV.
           MOVE IV-CDAZ  TO KLV-AZI.
           MOVE MOV-IVA  TO KLV-COD.
           WRITE RF-LAV INVALID
                 MOVE 'vcon142: errore WR.LAV' TO MESS
                 GO TO ERRIO.
      ************
           GO TO C10.
       C99.
           EXIT.
      *------------------
      * Nota: l'ID assegnato a ID-142 deve essere uguale anche
      *       in vcon140, vcon190 e vcon143
       CREA-IDLAV.
           MOVE SPACE TO ID-142.
           STRING 'w9' PID DELIMITED SPACE INTO ID-142.
      **** rel 4.1a
           MOVE SPACE TO ID-LAV.
           STRING 'w8' PID DELIMITED SPACE INTO ID-LAV.
      ************
       EX-CREA-IDLAV.
           EXIT.
      *------------------
      **** rel 4.1a
       LOOP-LAV.
           MOVE ZERO TO TOTCVEN K1.
           MOVE LOW-VALUE TO KEYLV.
           MOVE IV-CDAZ   TO KLV-AZI.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO EX-LOOP-LAV.
       RDLV-NEXT.
           READ WDSLAV NEXT AT END GO TO EX-LOOP-LAV.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RDLV-NEXT.
           ADD 1 TO K1.

           MOVE 3       TO KTB-TIP.
           MOVE KLV-COD TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.

           IF LAV-AVEN = ZERO AND
              LAV-PAVE = ZERO GO TO RDLV-NEXT.

           ADD LAV-AVEN TO TOTCVEN.
           ADD LAV-PAVE TO TOTCVEN.
           GO TO RDLV-NEXT.
       EX-LOOP-LAV.
           EXIT.
      *------------------
      ************
