       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRXCMN.
      *
      *    Modifica Competenza 
      *
      **** rel 7.2
      * nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'griacosl'.
           COPY 'gritabsl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'griaco'.
           COPY 'gritab'.
           COPY 'griclf'.
           COPY 'grimov'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'grimovrk'.
           COPY 'gritabrk'.
           COPY 'grit25rk'.
           COPY 'grit35rk'.
           COPY 'griclfrk'.
           COPY 'parzf'.
           COPY 'parmb'.
           COPY 'parcdt'.
           COPY 'zoom-v'.
           COPY 'parppar'.
           COPY 'parvmov'.
      *
       01  ID-AZI  PIC X(15) VALUE 'anaazi'.
       01  ID-CON  PIC X(15) VALUE 'anacon'.
       01  ID-ACO  PIC X(15) VALUE 'appcon'.
       01  ID-TAB  PIC X(15) VALUE 'tabell'.
       01  ID-CLF  PIC X(15) VALUE 'anaclf'.
       01  ID-MOV  PIC X(15) VALUE 'movime'.
      *
       01  SF-AZI  PIC XX.
       01  SF-CON  PIC XX.
       01  SF-ACO  PIC XX.
       01  SF-TAB  PIC XX.
       01  SF-CLF  PIC XX.
       01  SF-MOV  PIC XX.
      *
       01  AREE.
           05 NPGMLVIEW PIC X(10) VALUE 'vrxcmnl'.
           05 NPGMZOOM  PIC X(10) VALUE 'vrxcmn'.
           05 CAMPO     PIC X(20).
           05 SEOLD     PIC X.

           05 TABK  OCCURS 9999.
              10 TABK1  PIC 9(7). *> cd conto
              10 TABK2  PIC 9(5). *> data reg
              10 TABK3  PIC 9(5). *> prg reg
      *
           05 KRIFER  PIC X(50).
           05 SAVRF   PIC X(500).
           05 SAV-AZI   PIC 999.
           05 SAV-COD   PIC 9(7).
      *
           05 MCLI    PIC 99.
           05 MFOR    PIC 99.
           05 CODCLI.
              10 MAS   PIC 99.
              10 COD   PIC 9(5).
      *
           05 DAT1      PIC 9(5).
           05 DAT2      PIC 9(5).
      *
           05 DATA1   PIC 9(5).
           05 DATA2   PIC 9(5).
           05 VALDAT  PIC 9(5).

           05 SAV-AA  PIC 9(2).
           05 SAV-MM  PIC 9(2).

           05 LNSEZ   PIC 999.
           05 INCR    PIC S9.
           05 Z-NREG  PIC ZZZZ9.
           05 DTAPE   PIC 9(5) COMP-3.
           05 DTINI   PIC 9(5).

      *    05 LF      PIC X     VALUE X'0A'.
      *
           COPY 'vrxcmn.cpy'.
      *
       LINKAGE SECTION.
           COPY 'gricmnrx'
           REPLACING GS-VRXCMN-AZI    BY GS-AZI
                     GS-VRXCMN-FUN    BY GS-FUN
                     GS-VRXCMN-IDX    BY GS-IDX
                     GS-VRXCMN-SV     BY GS-SV 
                     GS-VRXCMN-SUB    BY GS-SUB
                     GS-VRXCMN-SEL    BY GS-SEL
                     RX-VRXCMN-FUN    BY RX-FUN
                     RX-VRXCMN-ST     BY RX-ST
                     RX-VRXCMN-POS    BY RX-POS
                     RX-VRXCMN-NUM    BY RX-NUM
                     RX-VRXCMN-LETTI  BY RX-LETTI
                     RX-VRXCMN-EOF    BY RX-EOF
                     RX-VRXCMN-RG-EOF BY RX-RG-EOF
                     RX-VRXCMN-CAMPO  BY RX-CAMPO.
      *
       01  IF-MESS    PIC X(204).
           COPY 'lview.cpy'.
       PROCEDURE DIVISION USING GS-VRXCMN-SHARED
                                RX-VRXCMN-CTRL
                                RX-VRXCMN-INT
                                IF-MESS
                                DATA-BLOCK.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclaco'.
           COPY 'dcltab'.
           COPY 'dclmov'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RX-ST RX-RG-EOF.
           MOVE SPACE TO IF-MESS.
           MOVE RX-FUN TO FUN.
           MOVE RX-NUM TO NUM.
           MOVE ZERO   TO RX-POS.
           MOVE GS-IDX TO IDX.
           IF SWINI = ZERO PERFORM PGM-INI THRU EX-PGM-INI.
      *
           IF FUN = '$'
              PERFORM GENERA-DATI THRU EX-GENERA-DATI
              GO TO ESCI.
      *
           IF FUN = '%'
              PERFORM TOGLI-DATI THRU EX-TOGLI-DATI
              GO TO ESCI.
      *
      *> parte con il caricamente dello zoom
           COPY 'zoom-i'.
           IF NOT (IDX = 1 OR 2 OR 3) MOVE 1 TO IDX GS-IDX.
      * 
           IF GS-VRXCMN-FL = ZERO 
              MOVE 'movime' TO ID-MOV
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'anaclf' TO ID-CLF
           ELSE                
              MOVE 'movmol' TO ID-MOV
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'anacfx' TO ID-CLF
           END-IF.                

           OPEN INPUT MOVIME.
           OPEN INPUT ANAAZI ANACLF TABELL ANACON.
           PERFORM MOVE-INT THRU EX-MOVE-INT.
       INI00.
           MOVE ZERO TO EOF LETTI.
           PERFORM MOVE-KEY THRU EX-MOVE-KEY.
           IF IDX = 1 PERFORM START-IDX1.
           IF EOF > ZERO GO TO ENDATI.

      * cerca primo record nel range richiesto
       CERCA.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.
           IF FUN = 'F' OR 'L' OR 'C' GO TO CARBUF.
           IF IDX = 1 GO TO CER90.
      *    ( controlla tramite chiave primaria se il record letto da
      *      secondario e' quello richiesto )
           IF KEYMV NOT = KRIFER GO TO CERCA.
      *
           COPY 'zoom-r'.
      *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RX-ST.
       FINE.
           CLOSE MOVIME ANAAZI ANACLF TABELL ANACON.
       ESCI.
           IF FUN = 'X' OR 'N' OR 'P'
              IF RX-POS NOT = ZERO
                 MOVE TABK1(RX-POS) TO GS-VRXCMN-COD
                 MOVE TABK2(RX-POS) TO GS-VRXCMN-DAT
                 MOVE TABK3(RX-POS) TO GS-VRXCMN-NUM.
      *
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RX-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griacoer'.
           COPY 'griconer'.
           COPY 'gritaber'.
           COPY 'griazier'.
           COPY 'grixxxer'.
      *------------------
      * procedure eseguite solo alla PRIMA chiamata
       PGM-INI.
      * 
           OPEN INPUT TABELL.
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                CLOSE TABELL
                GO TO ERRIO.
           CLOSE TABELL.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
qui        MOVE ZERO    TO RX-VRXCMN-TIP-AV.
           MOVE ZERO    TO RX-VRXCMN-CDCON.
      *    MOVE ZERO    TO RX-VRXCMN-TIP-COM.
      *    MOVE '9'     TO RX-VRXCMN-TIP-IVA.
      *    MOVE ZERO    TO RX-VRXCMN-DTDOC-1.
      *    MOVE ZERO    TO RX-VRXCMN-DTDOC-2.
      *    MOVE SPACE   TO RX-VRXCMN-COD-ATT.
      *    MOVE "Tutte" TO RX-VRXCMN-ATT-D.
      *
           MOVE 1 TO SWINI.
       EX-PGM-INI.
           EXIT.
      *------------------
       START-IDX1.
           IF FUN = 'T' OR 'L'
              START MOVIME KEY <= KEYMV INVALID MOVE 1 TO EOF
           ELSE
              START MOVIME KEY >= KEYMV INVALID MOVE 3 TO EOF.
      *------------------
       READ-N-P.
           IF FUN = 'T' OR 'L'
              READ MOVIME PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ MOVIME NEXT AT END MOVE 3 TO EOF.
      *------------------
       MOVE-KEY.
           MOVE LOW-VALUE TO KEYMV.
           IF FUN = 'L' MOVE HIGH-VALUE TO KEYMV.
      * caricamento campi chiave fissi
           MOVE GS-AZI          TO KMV-AZI.
           MOVE GS-VRXCMN-VAL-1 TO KMV-CON.
      *
           IF FUN = 'C'        GO TO MOVE-KEY-C.
           IF FUN = 'B' OR 'T' GO TO MOVE-KEY-N-P.
           GO TO EX-MOVE-KEY.
       MOVE-KEY-C.
           GO TO EX-MOVE-KEY.
       MOVE-KEY-N-P.
           MOVE GS-AZI        TO KMV-AZI.
           MOVE TABK1(RIGRIF) TO KMV-CON.
           MOVE TABK2(RIGRIF) TO KMV-DAT.
           MOVE TABK3(RIGRIF) TO KMV-NUM.
           MOVE KEYMV TO KRIFER.
           IF IDX = 1 GO TO EX-MOVE-KEY.
      * acquisizione chiavi secondarie tramite lettura da primario
       EX-MOVE-KEY.
           EXIT.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-MOV = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
      *
           IF RX-VRXCMN-CDCON NOT = ZERO
              IF KMV-AZI = GS-AZI AND
                 KMV-CON  = RX-VRXCMN-CDCON GO TO EX-TEST-EOL
              END-IF
           ELSE
              IF KMV-AZI = GS-AZI
                 GO TO EX-TEST-EOL.
      *
           IF FUN = 'T' OR 'L'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
       EX-TEST-EOL.
           EXIT.
      *------------------
       MOVE-REC.
           IF RF-MOV = LOW-VALUE GO TO EX-MOVE-REC.
      *
      *    ( inserire qui controlli se ci sono records
      *      da escludere prima di incontrare BOF/EOF:
      *      per skip record GO TO EX-MOVE-REC )
      *
           IF KMV-AZI NOT = GS-AZI      GO TO EX-MOVE-REC.
           MOVE RF-MOV  TO REKMOV.

           IF VALDAT > DATA1
              IF MOV-DAT < VALDAT GO TO EX-MOVE-REC
              END-IF 
           ELSE
              IF MOV-DAT < DATA1  GO TO EX-MOVE-REC.
           IF DATA2 NOT = ZERO
              IF MOV-DAT > DATA2 GO TO EX-MOVE-REC.
           IF MOV-FLAG NOT = ZERO GO TO EX-MOVE-REC.

      *
      *> filtri
           PERFORM CONTROLLA-FILTRI THRU EX-CONTROLLA-FILTRI.
           IF FLGOK = ZERO
              IF FUN = 'U' 
                 PERFORM DELETE-ITEM THRU EX-DELETE-ITEM
                 GO TO MOVE-END
              ELSE
                 GO TO EX-MOVE-REC.
      *
           MOVE LOW-VALUE  TO RIG1.
      *
           MOVE '08'       TO LVDATA-ICON.
      *
           MOVE MOV-NPRGI  TO NPRGI.
      *
           MOVE GS-AZI     TO KPC-AZI.
           MOVE MOV-CON    TO CONTO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DESCR.
           MOVE CON-DESCR  TO DCONTO.
      *   
           MOVE MOV-AZI    TO KCF-AZI.
           MOVE MOV-ACF    TO KCF-COD.
           READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS.
           MOVE CLF-RGS    TO CLIENTE.

           MOVE MOV-DAT    TO AAGGG.
           MOVE 2          TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA     TO DTREG.
      *
           MOVE MOV-NREG   TO NREG.
      *
           MOVE MOV-DTDOC  TO AAGGG.
           MOVE 2          TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA     TO DTDOC.
      *
           MOVE MOV-NDOC   TO NDOC.
      *
           MOVE 3          TO KTB-TIP.
           MOVE MOV-IVA    TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                            MOVE ALL '*' TO T03-DSIVA.
           MOVE T03-DSIVA  TO IVA.
           MOVE MOV-CAUS   TO CAU.
           IF MOV-FLGPC = ZERO MOVE SPACE TO FLGECOM
           ELSE                MOVE '*'   TO FLGECOM.
           MOVE MOV-CATT   TO CAT.
      *
           MOVE SPACE      TO FL
           IF MOV-TIP = 4 
              MOVE MOV-IML TO IMPREG
           ELSE           
              MOVE MOV-IMP TO IMPREG
           END-IF
           MOVE MOV-IMPO TO IMPIVA
      *
           MOVE LF TO LF1.
      *
           PERFORM CARICA-LVIEW THRU EX-CARICA-LVIEW.
       MOVE-END.

           MOVE KMV-CON TO TABK1(NR).
           MOVE KMV-DAT TO TABK2(NR).
           MOVE KMV-NUM TO TABK3(NR).
      *
           ADD 1 TO LETTI.
           IF FUN = 'T' OR 'L'
              MOVE NR TO KMIN
           ELSE
              MOVE NR TO KMAX.
      *
           ADD 1 TO NR.
       EX-MOVE-REC.
           EXIT.
      *------------------
       MOVE-INT.
      * carica dati intestazione
           MOVE SPACE TO RX-VRXCMN-CDCON-D.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
           IF RX-VRXCMN-TIP-AV = ZERO
              MOVE T01-CIVAQ TO RX-VRXCMN-CDCON
              MOVE T01-CIVAQ TO GS-VRXCMN-VAL-1
           ELSE
              MOVE T01-CIVAV TO RX-VRXCMN-CDCON
              MOVE T01-CIVAV TO GS-VRXCMN-VAL-1
           END-IF.
      *
           MOVE GS-AZI   TO KPC-AZI.
           MOVE RX-VRXCMN-CDCON TO KPC-COD RX-VRXCMN-CDCON.
           READ ANACON INTO REKCON INVALID KEY
                MOVE ALL '*' TO CON-DESCR.
           MOVE CON-DESCR    TO RX-VRXCMN-CDCON-D.
      *
           MOVE 1               TO TIPOP1.
           MOVE GS-VRXCMN-DAT-2 TO GGMMAA.
           CALL 'rdata'      USING PARCDT.
           MOVE AAGGG           TO DATA2.
      *
           MOVE GS-VRXCMN-DAT-1 TO GGMMAA.
           CALL 'rdata'      USING PARCDT.
           MOVE AAGGG           TO DATA1.
      *
           MOVE GS-VRXCMN-VAL-D TO GGMMAA.
           CALL 'rdata'      USING PARCDT.
           MOVE AAGGG           TO VALDAT.
      *
           MOVE 35                TO T35-TIP.
           MOVE GS-AZI            TO T35-CDAZ.
           MOVE RX-VRXCMN-COD-ATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID MOVE SPACE TO T35-DATT.
           MOVE T35-DATT TO RX-VRXCMN-ATT-D.
      *
           MOVE 2                 TO KTB-TIP.
           MOVE RX-VRXCMN-COD-CAU TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
           MOVE TAB-DESCR         TO RX-VRXCMN-CAU-D.
      *
           MOVE 3                 TO KTB-TIP.
           MOVE RX-VRXCMN-COD-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
           MOVE TAB-DESCR         TO RX-VRXCMN-IVA-D.
      *
       EX-MOVE-INT.
           EXIT.
      *------------------
       CONTROLLA-FILTRI.
           MOVE ZERO TO FLGOK.
      *
      * filtri aggiuntivi
      *
           MOVE RX-VRXCMN-DTDOC-1 TO GGMMAA.
           MOVE 1                 TO TIPOP1.
           CALL 'rdata'        USING PARCDT.
           IF MOV-DTDOC < AAGGG    GO TO EX-CONTROLLA-FILTRI.
      *
           MOVE RX-VRXCMN-DTDOC-2 TO GGMMAA.
           MOVE 1                 TO TIPOP1.
           CALL 'rdata'        USING PARCDT.
           IF AAGGG NOT = ZERO  
              IF MOV-DTDOC > AAGGG GO TO EX-CONTROLLA-FILTRI.
      *
           IF RX-VRXCMN-CDCON NOT = ZERO
              IF KMV-CON NOT = RX-VRXCMN-CDCON 
                                   GO TO EX-CONTROLLA-FILTRI.
      *
           MOVE 3          TO KTB-TIP.
           MOVE MOV-IVA    TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                            MOVE ZERO TO T03-TPIVA.
      *
           IF RX-VRXCMN-COD-ATT NOT = SPACE
              IF MOV-CATT NOT = RX-VRXCMN-COD-ATT
                                 GO TO EX-CONTROLLA-FILTRI.
      *
           IF RX-VRXCMN-TIP-IVA NOT = '9'
              IF T03-TPIVA NOT = RX-VRXCMN-TIP-IVA
                                 GO TO EX-CONTROLLA-FILTRI.
      *
           IF RX-VRXCMN-TIP-COM > ZERO
              IF MOV-FLGPC = 1
                                 GO TO EX-CONTROLLA-FILTRI.
      *
           IF RX-VRXCMN-COD-CAU > ZERO
              IF MOV-CAUS NOT = RX-VRXCMN-COD-CAU
                                 GO TO EX-CONTROLLA-FILTRI.
      *
           IF RX-VRXCMN-COD-IVA > ZERO
              IF MOV-IVA NOT = RX-VRXCMN-COD-IVA
                                 GO TO EX-CONTROLLA-FILTRI.
      *
           MOVE 1 TO FLGOK.
       EX-CONTROLLA-FILTRI.
           EXIT.
      *------------------
       UPDATE-ITEM.
           MOVE LVITEM-TEXT(2)   TO NRIGAX.
           MOVE NRIGA            TO RX-POS FOCUSNR.
           MOVE LV-NUMERIC-VALUE TO PGZ-POSLV.
           PERFORM CONTROLLA-POS.
      *
           IF GS-VRXCMN-FL = ZERO 
              MOVE 'movime' TO ID-MOV
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'anaclf' TO ID-CLF
           ELSE                
              MOVE 'movmol' TO ID-MOV
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'anacfx' TO ID-CLF
           END-IF.                
           OPEN INPUT MOVIME
           OPEN INPUT ANACLF TABELL ANACON.
           MOVE GS-AZI        TO KMV-AZI
           MOVE TABK1(RX-POS) TO KMV-CON
           MOVE TABK2(RX-POS) TO KMV-DAT
           MOVE TABK3(RX-POS) TO KMV-NUM
           READ MOVIME INVALID GO TO EX-UPDATE-ITEM.
      *
           MOVE NR            TO SAVNR.
           MOVE PGZ-POSLV     TO LV-NUMERIC-VALUE.
           MOVE FOCUSNR       TO NR.
           PERFORM MOVE-REC THRU MOVE-END.
           CLOSE MOVIME.
           CLOSE ANACLF TABELL ANACON.
           MOVE SAVNR         TO NR.
       EX-UPDATE-ITEM.
           EXIT.
      *------------------
       INSERT-ITEM.
       EX-INSERT-ITEM.
           EXIT.
      *------------------
       V-DATI.
      * validazione dei campi filtri
           MOVE ZERO TO VFLD.
           MOVE RX-CAMPO TO CAMPO.
      *
       V-TIVA.
           MOVE 'TIVA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = RX-CAMPO GO TO E-TIVA.
      *
       E-TIVA.
      *
       V-DAT-1.
           MOVE 'DAT-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = RX-CAMPO GO TO E-DAT-1.
           MOVE 1 TO TIPOP1.
           MOVE RX-VRXCMN-DTDOC-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DAT1.
       E-DAT-1.
      *
       V-DAT-2.
           MOVE 'DAT-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = RX-CAMPO GO TO E-DAT-2.
           MOVE 1 TO TIPOP1.
           MOVE RX-VRXCMN-DTDOC-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DAT2.
           IF DAT1 > DAT2 
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DAT-2.
      *
       V-CAT.
           MOVE 'ATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = RX-CAMPO GO TO E-CAT.
           IF RX-VRXCMN-COD-ATT = SPACE
              MOVE "Tutte"               TO RX-VRXCMN-ATT-D
              GO TO E-CAT.
      *
           IF RX-VRXCMN-COD-ATT = "0"
              MOVE "Attivit Principale" TO RX-VRXCMN-ATT-D
              GO TO E-CAT.
      *
           OPEN INPUT TABELL.
      *
           MOVE 35         TO T35-TIP.
           MOVE GS-AZI     TO T35-CDAZ.
           MOVE RX-VRXCMN-COD-ATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID KEY
              PERFORM ERR-CINE
              CLOSE TABELL
              GO TO V-ERROR.
           MOVE T35-DATT TO RX-VRXCMN-ATT-D.
      *
           CLOSE TABELL.
      *
       E-CAT.
      *
       V-CAU.
           MOVE 'CAU' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = RX-CAMPO GO TO E-CAU.
           IF RX-VRXCMN-COD-CAU = SPACE
              MOVE "Tutte"               TO RX-VRXCMN-CAU-D
              GO TO E-CAU.
      *
           OPEN INPUT TABELL.
      *
           MOVE 2                 TO KTB-TIP.
           MOVE RX-VRXCMN-COD-CAU TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
      *
           MOVE TAB-DESCR TO RX-VRXCMN-CAU-D.
      *
           CLOSE TABELL.
      *
       E-CAU.
      *
       V-IVA.
           MOVE 'IVA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = RX-CAMPO GO TO E-IVA.
           IF RX-VRXCMN-COD-IVA = ZERO
              MOVE "Tutte"               TO RX-VRXCMN-IVA-D
              GO TO E-IVA.
      *
           OPEN INPUT TABELL.
      *
           MOVE 3                 TO KTB-TIP.
           MOVE RX-VRXCMN-COD-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
      *
           MOVE TAB-DESCR TO RX-VRXCMN-IVA-D.
      *
           CLOSE TABELL.
      *
       E-IVA.
      *

           GO TO EX-V-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
       INIZIA-ZOOM.
           MOVE 1 TO LV-ICONSWANTED.
           PERFORM CREA-LVIEW THRU EX-CREA-LVIEW.
      *
           IF GS-SV   = ZERO     GO TO EX-INIZIA-ZOOM.
           IF PGZ-ST  NOT = ZERO GO TO EX-INIZIA-ZOOM.
      *
           MOVE PGZ-FILT(1)(1:1)  TO GS-FUN.
           MOVE PGZ-FILT(2)(1:1)  TO GS-IDX.

           MOVE PGZ-FILT(3)(1:6) TO RX-VRXCMN-DTDOC-1.
           MOVE PGZ-FILT(4)(1:6) TO RX-VRXCMN-DTDOC-2.
           MOVE PGZ-FILT(5)(1:1) TO RX-VRXCMN-TIP-IVA.
           MOVE PGZ-FILT(6)(1:1) TO RX-VRXCMN-TIP-COM.
           MOVE PGZ-FILT(7)(1:1) TO RX-VRXCMN-COD-ATT.
           MOVE PGZ-FILT(8)(1:3) TO RX-VRXCMN-COD-CAU.
           MOVE PGZ-FILT(9)(1:3) TO RX-VRXCMN-COD-IVA.
      *
      * filtri aggiuntivi
       EX-INIZIA-ZOOM.
           EXIT.
      *------------------
      * eventuali dati da aggiornare a seguito cancellazione/inserimento
      * /modifica
      * es. totale documento
       AGG-PIEDE.
       EX-AGG-PIEDE.
           EXIT.
      *------------------
       SAVE-OPZI.
           MOVE GS-FUN         TO PGZ-FILT(1)(1:1).
           MOVE GS-IDX         TO PGZ-FILT(2)(1:1).
      *
           MOVE RX-VRXCMN-DTDOC-1 TO PGZ-FILT(3)(1:6).
           MOVE RX-VRXCMN-DTDOC-2 TO PGZ-FILT(4)(1:6).
           MOVE RX-VRXCMN-TIP-IVA TO PGZ-FILT(5)(1:1).
           MOVE RX-VRXCMN-TIP-COM TO PGZ-FILT(6)(1:1).
           MOVE RX-VRXCMN-COD-ATT TO PGZ-FILT(7)(1:1).
           MOVE RX-VRXCMN-COD-CAU TO PGZ-FILT(8)(1:3).
           MOVE RX-VRXCMN-COD-IVA TO PGZ-FILT(9)(1:3).
      *
      * filtri aggiuntivi
      *
           MOVE GS-AZI     TO PGZ-AZI.
           MOVE 'o'        TO PGZ-FUN.
           MOVE NPGMZOOM   TO PGZ-ZOOM.
           MOVE NPGMLVIEW  TO PGZ-NPGM.
           MOVE SPACE      TO PGZ-DATI.
           CALL 'vrgenzom' USING PARGZOOM IF-MESS Data-Block.
       EX-SAVE-OPZI.
           EXIT.
      *------------------
       GENERA-DATI.
      *
           IF GS-VRXCMN-FL = ZERO 
              MOVE 'movime' TO ID-MOV
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'anaclf' TO ID-CLF
           ELSE                
              MOVE 'movmol' TO ID-MOV
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'anacfx' TO ID-CLF
           END-IF.                
           OPEN INPUT MOVIME.
           OPEN INPUT ANAAZI ANACLF TABELL ANACON.
      *
           MOVE GS-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
                       PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
      *
           MOVE AZI-DTAPE TO DTAPE.
           IF T25-ESE = 1 MOVE AZI-DTAPE  TO AAGGG
                          MOVE 2          TO TIPOP1
                          CALL 'rdata' USING PARCDT
                          MOVE 1 TO GG9
                          MOVE 1 TO MM9
                          MOVE 1 TO TIPOP1
                          CALL 'rdata' USING PARCDT
                          MOVE AAGGG      TO DTAPE.
      *
           IF T25-DUP = ZERO 
              MOVE DTAPE   TO DTINI
           ELSE 
              MOVE T25-DUP TO DTINI
           END-IF.
      *
           MOVE GS-AZI        TO KMV-AZI
           MOVE GS-VRXCMN-COD TO KMV-CON
           MOVE GS-VRXCMN-DAT TO KMV-DAT
           MOVE GS-VRXCMN-NUM TO KMV-NUM
           READ MOVIME INTO REKMOV INVALID GO TO FN-GENERA-DATI.
      *
           MOVE MOV-NREG   TO Z-NREG
      *
           MOVE MOV-DAT    TO AAGGG
           MOVE 2          TO TIPOP1
           CALL 'rdata' USING PARCDT
           MOVE AA9        TO SAV-AA
           MOVE MM9        TO SAV-MM

           IF MM9 = 1
               MOVE SPACE                         TO F-MES1
               STRING 'Attenzione, registrazione ' DELIMITED BY SIZE
                      Z-NREG                       DELIMITED BY SIZE
                                                INTO F-MES1
               END-STRING
               MOVE 'Movimento nel mese di Gennaio     ' TO F-MES2
               MOVE 'Variazione competenza Iva non ammessa' TO F-MES3
               MOVE 3 TO F-NMES
               MOVE 'W' TO MB-TIPO
      *        CALL 'vrmbox' USING PARMB
               GO  TO  FN-GENERA-DATI
           END-IF.
      *
           IF GG9 > 15
               MOVE SPACE                         TO F-MES1
               STRING 'Attenzione, registrazione ' DELIMITED BY SIZE
                      Z-NREG                       DELIMITED BY SIZE
                                                INTO F-MES1
               END-STRING
               MOVE 'Data  movimento superiore al 15 del mese' TO F-MES2
               MOVE 'Variazione competenza Iva non ammessa' TO F-MES3
               MOVE 3 TO F-NMES
               MOVE 'W' TO MB-TIPO
               CALL 'vrmbox' USING PARMB
               GO  TO  FN-GENERA-DATI
           END-IF.
      *
           MOVE MOV-DTDOC  TO AAGGG
           MOVE 2          TO TIPOP1
           CALL 'rdata' USING PARCDT
           IF AA9 = SAV-AA AND
              MM9 = SAV-MM
               MOVE SPACE                         TO F-MES1
               STRING 'Attenzione, registrazione ' DELIMITED BY SIZE
                      Z-NREG                       DELIMITED BY SIZE
                                                INTO F-MES1
               END-STRING
               MOVE 'Mese documento uguale a mese movimento' 
                                                         TO F-MES2
               MOVE 'Variazione competenza Iva non ammessa ' TO F-MES3
               MOVE 3 TO F-NMES
               MOVE 'W' TO MB-TIPO
               CALL 'vrmbox' USING PARMB
               GO TO FN-GENERA-DATI
           END-IF.
      *
           MOVE DTINI      TO AAGGG
           MOVE 2          TO TIPOP1
           CALL 'rdata' USING PARCDT
           IF MM9 = (SAV-MM - 1)
               MOVE "Registro IVA gia' stampato in definitivo"
                                                         TO F-MES1
               MOVE "Variazione competenza Iva non ammessa " 
                                                         TO F-MES2
               MOVE 2 TO F-NMES
               MOVE 'W' TO MB-TIPO
               CALL 'vrmbox' USING PARMB
               GO TO FN-GENERA-DATI
           END-IF.
      *
           MOVE ZERO          TO PARVMOV.
           MOVE 'R'           TO PMV-FUN.
           MOVE GS-AZI        TO PMV-AZI.
           MOVE MOV-NREG      TO PMV-NREG.
           MOVE MOV-DAT       TO PMV-DREG.
           MOVE 1             TO PMV-FLAG
           MOVE GS-VRXCMN-FL  TO PMV-FL.
      *
           CALL 'varmov'   USING PARVMOV.
      *
       FN-GENERA-DATI.
      *
      *
       FX-GENERA-DATI.
      *
           CLOSE MOVIME.
           CLOSE ANAAZI ANACLF TABELL ANACON.
      *
       EX-GENERA-DATI.
           EXIT.
      *------------------
       TOGLI-DATI.
      *
           IF GS-VRXCMN-FL = ZERO 
              MOVE 'movime' TO ID-MOV
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'anaclf' TO ID-CLF
           ELSE                
              MOVE 'movmol' TO ID-MOV
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'anacfx' TO ID-CLF
           END-IF.                
           OPEN INPUT MOVIME.
           OPEN INPUT ANAAZI ANACLF TABELL ANACON.
      *
           MOVE GS-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
                       PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
      *
           MOVE AZI-DTAPE TO DTAPE.
           IF T25-ESE = 1 MOVE AZI-DTAPE  TO AAGGG
                          MOVE 2          TO TIPOP1
                          CALL 'rdata' USING PARCDT
                          MOVE 1 TO GG9
                          MOVE 1 TO MM9
                          MOVE 1 TO TIPOP1
                          CALL 'rdata' USING PARCDT
                          MOVE AAGGG      TO DTAPE.
      *
           IF T25-DUP = ZERO 
              MOVE DTAPE   TO DTINI
           ELSE 
              MOVE T25-DUP TO DTINI
           END-IF.
      *
           MOVE GS-AZI        TO KMV-AZI
           MOVE GS-VRXCMN-COD TO KMV-CON
           MOVE GS-VRXCMN-DAT TO KMV-DAT
           MOVE GS-VRXCMN-NUM TO KMV-NUM
           READ MOVIME INTO REKMOV INVALID GO TO FN-TOGLI-DATI.
      *
           MOVE MOV-DAT    TO AAGGG
           MOVE 2          TO TIPOP1
           CALL 'rdata' USING PARCDT
           MOVE AA9        TO SAV-AA
           MOVE MM9        TO SAV-MM
      *
           MOVE DTINI      TO AAGGG
           MOVE 2          TO TIPOP1
           CALL 'rdata' USING PARCDT
           IF MM9 = (SAV-MM - 1)
               MOVE "Registro IVA gia' stampato in definitivo"
                                                         TO F-MES1
               MOVE "Variazione competenza Iva non ammessa " 
                                                         TO F-MES2
               MOVE 2 TO F-NMES
               MOVE 'W' TO MB-TIPO
               CALL 'vrmbox' USING PARMB
               GO TO FN-TOGLI-DATI
           END-IF.
      *
           MOVE ZERO          TO PARVMOV.
           MOVE 'R'           TO PMV-FUN.
           MOVE GS-AZI        TO PMV-AZI.
           MOVE MOV-NREG      TO PMV-NREG.
           MOVE MOV-DAT       TO PMV-DREG.
           MOVE ZERO          TO PMV-FLAG
           MOVE GS-VRXCMN-FL  TO PMV-FL.
      *
           CALL 'varmov'   USING PARVMOV.
      *
       FN-TOGLI-DATI.
      *
      *
       FX-TOGLI-DATI.
      *
           CLOSE MOVIME.
           CLOSE ANAAZI ANACLF TABELL ANACON.
      *
       EX-TOGLI-DATI.
           EXIT.
      *------------------
