       IDENTIFICATION DIVISION.
       PROGRAM-ID. VARMOV.
      *
      **** rel 7.2
      *    Nuovo
      ************
      * OGGETTO: Variazione Flag competenza movimenti contabili
      *
      *------------------------------------------------------------*
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *
           COPY 'gritabsl'.
           COPY 'grimovsl'.
      *
       DATA DIVISION.
       FILE SECTION.
      *
           COPY 'gritab'.
           COPY 'grimov'.
      *
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'grimovrk'.
           COPY 'parzf'.
           COPY 'parrd'.
           COPY 'parmb'.
           COPY 'parcdt'.
      **** rel 7.1
           COPY 'parppar'.
      ************
      *
       01  COMODI.
           05 ID-MOV     PIC X(15) VALUE 'movime'.
           05 ID-TAB     PIC X(15) VALUE 'tabell'.
           05 SF-MOV     PIC XX.
           05 SF-TAB     PIC XX.
      *
           05 MESS       PIC X(40)      VALUE SPACE.
           05 SWOPE      PIC 9          VALUE ZERO.
           05 SWINI      PIC 9          VALUE ZERO.
      *
       LINKAGE SECTION.
           COPY 'parvmov'.
       PROCEDURE DIVISION USING PARVMOV.
           COPY 'declxer1'.
           COPY 'dclmov'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
      *
           IF PMV-FUN = 'C'
              PERFORM CL-FILE
              GO TO FINE.
      *
           COPY 'strsub'.
      *
           IF PMV-FUN = 'O'
              PERFORM OP-FILE
              GO TO FINE.
      *
           INITIALIZE PMV-OUTPUT.
      *
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.

           PERFORM OP-FILE.
      *
           PERFORM ELABORA-PMV THRU EX-ELABORA-PMV
      *
           GO TO CHIUDI.
      *---------------------*
       ERRIO.
           COPY 'errsub'.
       CHIUDI.
           IF ERRIO-ST NOT = ZERO OR
              PMV-FUN NOT = 'X'
                 PERFORM CL-FILE.
      *
       FINE.
           EXIT PROGRAM.
           COPY 'errmes'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
      *
           MOVE 1 TO SWINI.
      *
       EX-INI-ELABORA.
           EXIT.
      *------------------
       OP-FILE.

           IF PMV-FL = ZERO 
              MOVE 'movime' TO ID-MOV
              MOVE 'tabell' TO ID-TAB
           ELSE                
              MOVE 'movmol' TO ID-MOV
              MOVE 'tabold' TO ID-TAB
           END-IF.                

           IF SWOPE = ZERO
              OPEN I-O   MOVIME
              OPEN INPUT TABELL
              MOVE 1 TO SWOPE.
      *------------------
       CL-FILE.
           IF SWOPE = 1
              CLOSE MOVIME
              CLOSE TABELL
              MOVE ZERO TO SWOPE.
      *------------------------------------*
       ELABORA-PMV.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO END-MOV-1.
      *
           MOVE LOW-VALUE TO RF-MOV.
           MOVE PMV-AZI   TO KMV-AZI.
           MOVE PMV-NREG  TO KM2-NREG.
           START MOVIME KEY NOT < KEYMV2 INVALID GO TO END-MOV-1.
       LOOP-MOV-1.
           READ MOVIME NEXT INTO REKMOV AT END   GO TO END-MOV-1.
           IF SF-MOV = '9D' OR '9A' OR '35'      GO TO LOOP-MOV-1.
           IF MOV-NREG > PMV-NREG                GO TO END-MOV-1.

           IF MOV-AZI NOT = PMV-AZI              GO TO LOOP-MOV-1.
           IF MOV-DAT NOT = PMV-DREG             GO TO LOOP-MOV-1.

           IF MOV-CON NOT = T01-CIVAQ AND
              MOV-CON NOT = T01-CIVAV
                                                 GO TO LOOP-MOV-1.

           MOVE PMV-FLAG TO MOV-FLGPC.
           MOVE REKMOV   TO RF-MOV.
           REWRITE RF-MOV INVALID GO TO LOOP-MOV-1.
      *
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      *
           GO TO LOOP-MOV-1.
       END-MOV-1.
      *
      *
       EX-ELABORA-PMV.
           EXIT.
      *------------------------------------*
      **** rel 7.1
       CALL-VSRV133-MOV.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'MOV'   TO PPAR-TARC.
           MOVE KEYMV   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           IF ID-MOV = 'movime' MOVE '0' TO PPAR-OPZ(81:1).
           IF ID-MOV = 'movmol' MOVE '1' TO PPAR-OPZ(81:1).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 MOV. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
      *------------------------------------*
